import * as React from 'react';
import { WithChildrenProp } from '..';
import { FillButton } from '../Button';
import { alertVariants } from './variants';
export type AlertType = keyof typeof alertVariants;
export type AlertPlacements = 'inline' | 'floating';
type AlertPlacementType = {
    type?: Exclude<AlertType, 'subtle'>;
    placement?: AlertPlacements;
} | {
    type: 'subtle';
    placement: 'inline';
};
export type AlertProps = WithChildrenProp & AlertPlacementType & {
    hidden?: boolean;
    className?: string;
    /** Callback to be called when the close icon is clicked */
    onClose?: () => void;
    /** Call to Action Configuration */
    cta?: Omit<React.ComponentProps<typeof FillButton>, 'variant' | 'mode' | 'size'> & {
        text?: string;
    };
};
export declare const Alert: React.FC<AlertProps>;
export {};
