function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0) { ; } } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { MiniChevronDownIcon, MiniDeleteIcon } from '@codecademy/gamut-icons';
import { breakpoints, useCurrentMode } from '@codecademy/gamut-styles';
import { isValidElement, useMemo, useState } from 'react';
import * as React from 'react';
import TruncateMarkup from 'react-truncate-markup';
import { useMedia } from 'react-use';
import { Rotation } from '..';
import { Box } from '../Box';
import { FillButton, IconButton, TextButton } from '../Button';
import { AlertBanner, AlertBox, alertContentProps, CollapsableContent } from './elements';
import { alertVariants, getGridTemplateColumns } from './variants';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export var Alert = function Alert(_ref) {
  var _alertVariants$type, _cta$children, _cta$children2;
  var children = _ref.children,
    cta = _ref.cta,
    onClose = _ref.onClose,
    hidden = _ref.hidden,
    _ref$type = _ref.type,
    type = _ref$type === void 0 ? 'general' : _ref$type,
    _ref$placement = _ref.placement,
    placement = _ref$placement === void 0 ? 'floating' : _ref$placement,
    props = _objectWithoutProperties(_ref, ["children", "cta", "onClose", "hidden", "type", "placement"]);
  var isDesktop = useMedia("(min-width: ".concat(breakpoints.xs, ")"));
  var activeAlert = (_alertVariants$type = alertVariants === null || alertVariants === void 0 ? void 0 : alertVariants[type]) !== null && _alertVariants$type !== void 0 ? _alertVariants$type : alertVariants.general;
  var Icon = activeAlert.icon,
    bg = activeAlert.bg;
  var currentColorMode = useCurrentMode();
  var isSubtleVariant = type === 'subtle';
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    expanded = _useState2[0],
    setExpanded = _useState2[1];
  var _useState3 = useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    truncated = _useState4[0],
    setTruncated = _useState4[1];
  var ctaExists = cta && Boolean((_cta$children = cta.children) !== null && _cta$children !== void 0 ? _cta$children : cta.text);
  var isInline = useMemo(function () {
    return placement === 'inline' || !isDesktop;
  }, [placement, isDesktop]);
  var toggleState = useMemo(function () {
    return expanded || isInline ? 'expanded' : 'collapsed';
  }, [expanded, isInline]);
  var ctaButtonPadding = useMemo(function () {
    return !isDesktop && placement === 'floating' ? 4 : undefined;
  }, [placement, isDesktop]);
  var gridButtonOrder = useMemo(function () {
    return isDesktop ? undefined : ['2',, 'auto'];
  }, [isDesktop]);
  var gridTemplateColumns = useMemo(function () {
    return !isDesktop ? "max-content minmax(0, 1fr) repeat(1, max-content)" : getGridTemplateColumns({
      cta: ctaExists,
      onClose: !!onClose,
      truncated: truncated
    });
  }, [ctaExists, isDesktop, onClose, truncated]);
  var tabIndex = hidden ? -1 : undefined;
  var floatingContent = expanded ? /*#__PURE__*/_jsx(Box, _objectSpread(_objectSpread({}, alertContentProps), {}, {
    children: children
  })) : /*#__PURE__*/_jsx(TruncateMarkup, {
    tokenize: "characters",
    ellipsis: /*#__PURE__*/_jsx("span", {
      children: "..."
    }),
    lines: 1,
    onTruncate: setTruncated,
    children: /*#__PURE__*/_jsx(Box, _objectSpread(_objectSpread({}, alertContentProps), {}, {
      children: React.Children.map(children, function (child) {
        return /*#__PURE__*/isValidElement(child) || typeof child === 'string' ? child : /*#__PURE__*/_jsx(TruncateMarkup.Atom, {
          children: child
        });
      })
    }))
  });
  var expandButton = truncated && !isInline && /*#__PURE__*/_jsx(Box, {
    children: /*#__PURE__*/_jsx(TextButton, {
      tabIndex: tabIndex,
      "aria-label": expanded ? 'Collapse' : 'Expand',
      variant: "secondary",
      size: "small",
      onClick: function onClick() {
        return setExpanded(!expanded);
      },
      children: /*#__PURE__*/_jsx(Rotation, {
        rotated: toggleState === 'expanded',
        children: /*#__PURE__*/_jsx(MiniChevronDownIcon, {})
      })
    })
  });
  var buttonColorMode = isSubtleVariant ? currentColorMode : 'dark';
  var ctaButton = ctaExists && /*#__PURE__*/_jsx(Box, {
    gridColumn: gridButtonOrder,
    gridRow: gridButtonOrder,
    pb: ctaButtonPadding,
    children: /*#__PURE__*/_jsx(FillButton, _objectSpread(_objectSpread({}, cta), {}, {
      mode: buttonColorMode,
      variant: "secondary",
      size: "small",
      tabIndex: tabIndex,
      children: (_cta$children2 = cta.children) !== null && _cta$children2 !== void 0 ? _cta$children2 : cta.text
    }))
  });
  var AlertWrapper = isSubtleVariant ? AlertBox : AlertBanner;
  return /*#__PURE__*/_jsxs(AlertWrapper, _objectSpread(_objectSpread({
    bg: bg,
    placement: placement,
    gridTemplateColumns: gridTemplateColumns
  }, props), {}, {
    children: [/*#__PURE__*/_jsx(Icon, {
      size: 32,
      "aria-hidden": true,
      p: 8
    }), /*#__PURE__*/_jsx(CollapsableContent, {
      animate: toggleState,
      "aria-expanded": expanded,
      initial: toggleState,
      transition: {
        duration: 0.2,
        ease: 'easeInOut'
      },
      variants: {
        collapsed: {
          height: '2rem'
        },
        expanded: {
          height: 'auto'
        }
      },
      children: isInline ? children : floatingContent
    }), expandButton, ctaButton, onClose && /*#__PURE__*/_jsx(IconButton, {
      tabIndex: tabIndex,
      "aria-label": "Close Alert",
      variant: "secondary",
      size: "small",
      onClick: onClose,
      icon: MiniDeleteIcon
    })]
  }));
};