import { MiniCheckCircleIcon, MiniInfoCircleIcon, MiniRemoveCircleIcon, MiniStarIcon, MiniWarningTriangleIcon } from '@codecademy/gamut-icons';
import { breakpoints, variant } from '@codecademy/gamut-styles';
export var alertVariants = {
  general: {
    order: 4,
    bg: 'blue',
    icon: MiniInfoCircleIcon
  },
  success: {
    order: 2,
    bg: 'green',
    icon: MiniCheckCircleIcon
  },
  error: {
    order: 1,
    bg: 'red-600',
    icon: MiniRemoveCircleIcon
  },
  notice: {
    order: 3,
    bg: 'orange',
    icon: MiniWarningTriangleIcon
  },
  feature: {
    order: 5,
    bg: 'blue-300',
    icon: MiniStarIcon
  },
  subtle: {
    bg: 'background-hover',
    icon: MiniInfoCircleIcon
  }
};
export var placementVariants = variant({
  prop: 'placement',
  base: {
    alignItems: 'start',
    columnGap: [4, 8,, 12],
    display: 'grid',
    maxWidth: "calc(".concat(breakpoints.md, " - 4rem)"),
    px: 4,
    width: 1
  },
  variants: {
    inline: {
      border: 'none',
      borderRadius: '3px',
      py: 8
    },
    floating: {
      borderColor: 'navy',
      borderRadius: '5px',
      borderStyle: 'solid',
      borderWidth: '2px',
      py: 4
    }
  }
});
export var getGridTemplateColumns = function getGridTemplateColumns(buttonExistenceObject) {
  var numOfButtons = Object.values(buttonExistenceObject).filter(function (item) {
    return item === true;
  }).length;
  var repeatCount = numOfButtons <= 0 ? 1 : numOfButtons;
  return "max-content minmax(0, 1fr) repeat(".concat(repeatCount, ", max-content)");
};