import { motion } from 'framer-motion';
import { ComponentProps } from 'react';
import * as React from 'react';
export interface RotationProps extends ComponentProps<typeof motion.div> {
    /**
     * Whether the container is rotated. Defaults to 180 (half a rotation)
     */
    rotated?: boolean;
    /**
     * Number of degrees to rotate. Should be under 360.
     */
    degrees?: number;
    /**
     * Height of container. Defaults to 16.†
     */
    height?: number;
    /**
     * Width of container. Defaults to 16.
     */
    width?: number;
}
export declare const Rotation: React.FC<RotationProps>;
