import * as React from 'react';
export type Crumb = {
    title: string;
};
export type ClickableCrumb<T extends string | Object> = Crumb & {
    href: string;
    payload: T;
};
export type Breadcrumb<T extends string | Object> = Crumb | ClickableCrumb<T>;
export declare const isClickableCrumb: <T extends string | Object>(crumb: Breadcrumb<T>) => crumb is ClickableCrumb<T>;
export type BreadcrumbsProps<T extends string | Object> = {
    crumbs: Breadcrumb<T>[];
    onClick?: (event: React.MouseEvent, crumb: ClickableCrumb<T>) => void;
    className?: string;
};
export declare const Breadcrumbs: <T extends string | Object>({ crumbs, onClick, className, }: BreadcrumbsProps<T>) => JSX.Element;
