import { HTMLProps, MutableRefObject } from 'react';
export type ButtonBaseElements = HTMLAnchorElement | HTMLButtonElement;
export type ButtonBaseRef = ((instance: ButtonBaseElements | null) => void) | MutableRefObject<ButtonBaseElements | null> | null;
export type ButtonBaseElementProps = HTMLProps<HTMLAnchorElement | HTMLButtonElement> & {
    as?: never;
    ref?: ButtonBaseRef;
};
export declare enum ButtonSelectors {
    HOVER = "&:hover",
    ACTIVE = "&:active",
    FOCUS = "&:focus",
    DISABLED = "[disabled], &:disabled, &[aria-disabled='true']",
    FOCUS_VISIBLE = " &:focus-visible",
    OUTLINE = "&:before",
    OUTLINE_FOCUS_VISIBLE = "&:focus-visible:before",
    SHADOW = "&:after",
    SHADOW_HOVER = "&:hover:after",
    SHADOW_ACTIVE = "&:active:after",
    SHADOW_DISABLED = "[disabled]:after, &:disabled:after, &[aria-disabled='true']:after"
}
export declare enum Selectors {
    BEFORE = "&::before",
    HOVER = "&:hover",
    FOCUS = "&:focus",
    DISABLED = "&[disabled], &:disabled",
    FOCUS_VISIBLE = "&:focus-visible"
}
export declare const resetStyles: (props: {
    theme?: import("@emotion/react").Theme | undefined;
}) => import("@codecademy/variance").CSSObject;
export declare const ButtonBase: import("react").ForwardRefExoticComponent<Pick<any, string | number | symbol> & import("react").RefAttributes<HTMLAnchorElement | HTMLButtonElement>>;
