import * as React from 'react';
import { WithChildrenProp } from '..';
import { PopoverProps } from '../Popover';
export interface CoachmarkProps extends WithChildrenProp {
    /**
     * Applied to the element to which the coachmark points.
     */
    activeElClassName?: string;
    /**
     * Amount of time (in ms) to delay rendering the coachmark.
     * @default 500
     */
    delay?: number;
    /**
     * Whether the coachmark is rendered.
     */
    shouldShow: boolean;
    /**
     * Function that returns the contents of the coachmark.
     */
    renderPopover: (onDismiss?: () => void) => JSX.Element;
    /**
     * Props to be passed into the popover component.
     */
    popoverProps?: Partial<PopoverProps>;
}
export declare const Coachmark: React.FC<CoachmarkProps>;
