function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
import _regeneratorRuntime from "@babel/runtime/regenerator";
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { forwardRef, useEffect, useMemo } from 'react';
import * as React from 'react';
import { FormProvider, useForm } from 'react-hook-form';
import { Form } from '../Form';
import { submitSuccessStatus } from './utils';
import { jsx as _jsx } from "react/jsx-runtime";
export var FormPropsContext = /*#__PURE__*/React.createContext({});
var PropsProvider = FormPropsContext.Provider;
export var ConnectedForm = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var children = _ref.children,
    onSubmit = _ref.onSubmit,
    onError = _ref.onError,
    defaultValues = _ref.defaultValues,
    _ref$validation = _ref.validation,
    validation = _ref$validation === void 0 ? 'onChange' : _ref$validation,
    _ref$disableFieldsOnS = _ref.disableFieldsOnSubmit,
    disableFieldsOnSubmit = _ref$disableFieldsOnS === void 0 ? false : _ref$disableFieldsOnS,
    _ref$resetOnSubmit = _ref.resetOnSubmit,
    resetOnSubmit = _ref$resetOnSubmit === void 0 ? false : _ref$resetOnSubmit,
    _ref$showRequired = _ref.showRequired,
    showRequired = _ref$showRequired === void 0 ? false : _ref$showRequired,
    validationRules = _ref.validationRules,
    _ref$wasSubmitSuccess = _ref.wasSubmitSuccessful,
    wasSubmitSuccessful = _ref$wasSubmitSuccess === void 0 ? undefined : _ref$wasSubmitSuccess,
    watchedFields = _ref.watchedFields,
    rest = _objectWithoutProperties(_ref, ["children", "onSubmit", "onError", "defaultValues", "validation", "disableFieldsOnSubmit", "resetOnSubmit", "showRequired", "validationRules", "wasSubmitSuccessful", "watchedFields"]);
  var _useForm = useForm({
      defaultValues: defaultValues,
      mode: validation
    }),
    clearErrors = _useForm.clearErrors,
    handleSubmit = _useForm.handleSubmit,
    formState = _useForm.formState,
    reset = _useForm.reset,
    trigger = _useForm.trigger,
    watch = _useForm.watch,
    methods = _objectWithoutProperties(_useForm, ["clearErrors", "handleSubmit", "formState", "reset", "trigger", "watch"]);
  var onInvalid = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(errors, event) {
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              onError === null || onError === void 0 ? void 0 : onError(errors, event);
              clearErrors();
              _context.next = 4;
              return trigger();
            case 4:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return function onInvalid(_x, _x2) {
      return _ref2.apply(this, arguments);
    };
  }();
  var isSubmitSuccessful = submitSuccessStatus(wasSubmitSuccessful, formState.isSubmitSuccessful);
  if (watchedFields) {
    // we're pretty exhaustively type-checking the props as they're passed in, so its fine to cast here.
    var fields = watch(watchedFields.fields);
    watchedFields.watchHandler(fields);
  }
  useEffect(function () {
    if (isSubmitSuccessful && resetOnSubmit) {
      reset(defaultValues);
    }
  }, [isSubmitSuccessful, resetOnSubmit, reset, defaultValues]);
  var contextValues = useMemo(function () {
    return {
      disableFieldsOnSubmit: disableFieldsOnSubmit,
      resetOnSubmit: resetOnSubmit,
      showRequired: showRequired,
      validationRules: validationRules,
      wasSubmitSuccessful: wasSubmitSuccessful
    };
  }, [disableFieldsOnSubmit, resetOnSubmit, showRequired, validationRules, wasSubmitSuccessful]);
  return /*#__PURE__*/_jsx(PropsProvider, {
    value: contextValues,
    children: /*#__PURE__*/_jsx(FormProvider, _objectSpread(_objectSpread({
      clearErrors: clearErrors,
      handleSubmit: handleSubmit,
      formState: formState,
      reset: reset,
      trigger: trigger,
      watch: watch
    }, methods), {}, {
      children: /*#__PURE__*/_jsx(Form, _objectSpread(_objectSpread({
        onSubmit: handleSubmit(onSubmit, onInvalid)
      }, rest), {}, {
        ref: ref,
        children: children
      }))
    }))
  });
});