import * as React from 'react';
import { FormGroupProps } from '..';
import { ConnectedField, FieldProps, SubmitContextProps } from './types';
export interface ConnectedFormGroupBaseProps extends Omit<FormGroupProps, 'label' | 'disabled' | 'description' | 'htmlFor'> {
    customError?: string;
    errorType?: 'initial' | 'absolute';
    hideLabel?: boolean;
    name: string;
    label: React.ReactNode;
    required?: boolean;
    showRequired?: boolean;
    tooltip?: any;
}
export interface ConnectedFormGroupProps<T extends ConnectedField> extends SubmitContextProps, ConnectedFormGroupBaseProps {
    /**
     * An object consisting of a `component` key to specify what ConnectedFormInput to render - the remaining key/value pairs are that components desired props.
     */
    field: Omit<React.ComponentProps<T>, 'name' | 'disabled'> & FieldProps<T>;
}
export declare function ConnectedFormGroup<T extends ConnectedField>({ customError, children, disabled, errorType, field, hideLabel, id, label, name, labelSize, spacing, tooltip, }: ConnectedFormGroupProps<T>): JSX.Element;
