function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0) { ; } } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { isNull, isUndefined, omit } from 'lodash';
import { useContext, useEffect, useMemo, useState } from 'react';
import { useFieldArray, useFormContext } from 'react-hook-form';
import { ConnectedForm, ConnectedFormGroup, FormPropsContext } from '.';
export var useConnectedForm = function useConnectedForm(_ref) {
  var defaultValues = _ref.defaultValues,
    validationRules = _ref.validationRules,
    watchedFields = _ref.watchedFields;
  return useMemo(function () {
    return {
      ConnectedFormGroup: ConnectedFormGroup,
      ConnectedForm: ConnectedForm,
      connectedFormProps: {
        defaultValues: defaultValues,
        validationRules: validationRules,
        watchedFields: watchedFields
      }
    };
  },
  // eslint-disable-next-line react-hooks/exhaustive-deps
  []);
};
export var submitSuccessStatus = function submitSuccessStatus(wasSubmitSuccessful, isSubmitSuccessful) {
  return (wasSubmitSuccessful || wasSubmitSuccessful === undefined) && isSubmitSuccessful;
};
export var useFormState = function useFormState() {
  // This is fixed in a later react-hook-form version:
  // https://github.com/react-hook-form/react-hook-form/issues/2887
  // eslint-disable-next-line @typescript-eslint/unbound-method
  var _useFormContext = useFormContext(),
    control = _useFormContext.control,
    formState = _useFormContext.formState,
    getValues = _useFormContext.getValues,
    register = _useFormContext.register,
    reset = _useFormContext.reset,
    setError = _useFormContext.setError,
    setValue = _useFormContext.setValue,
    watch = _useFormContext.watch,
    clearErrors = _useFormContext.clearErrors;
  var _useContext = useContext(FormPropsContext),
    disableFieldsOnSubmit = _useContext.disableFieldsOnSubmit,
    showRequired = _useContext.showRequired,
    validationRules = _useContext.validationRules,
    wasSubmitSuccessful = _useContext.wasSubmitSuccessful;
  var isSubmitting = formState.isSubmitting,
    isDirty = formState.isDirty,
    errors = formState.errors;
  var isSubmitSuccessful = submitSuccessStatus(wasSubmitSuccessful, formState.isSubmitSuccessful);
  return {
    control: control,
    errors: errors,
    formState: formState,
    getValues: getValues,
    isDirty: isDirty,
    isDisabled: (isSubmitting || isSubmitSuccessful) && disableFieldsOnSubmit,
    register: register,
    reset: reset,
    setError: setError,
    setValue: setValue,
    showRequired: showRequired,
    useFieldArray: useFieldArray,
    validationRules: validationRules,
    watch: watch,
    clearErrors: clearErrors
  };
};
export var useField = function useField(_ref2) {
  var _errors$name, _ref3;
  var name = _ref2.name,
    disabled = _ref2.disabled,
    loading = _ref2.loading;
  // This is fixed in a later react-hook-form version:
  // https://github.com/react-hook-form/react-hook-form/issues/2887
  // eslint-disable-next-line @typescript-eslint/unbound-method
  // eslint-disable-next-line @typescript-eslint/unbound-method
  var _useFormState = useFormState(),
    control = _useFormState.control,
    errors = _useFormState.errors,
    register = _useFormState.register,
    formStateDisabled = _useFormState.isDisabled,
    setError = _useFormState.setError,
    setValue = _useFormState.setValue,
    showRequired = _useFormState.showRequired,
    validationRules = _useFormState.validationRules;
  var error = (_errors$name = errors[name]) === null || _errors$name === void 0 ? void 0 : _errors$name.message;
  var _useSubmitState = useSubmitState({
      disabled: disabled || formStateDisabled,
      loading: loading
    }),
    isDisabled = _useSubmitState.isDisabled,
    isLoading = _useSubmitState.isLoading;
  var validation = (_ref3 = validationRules && validationRules[name]) !== null && _ref3 !== void 0 ? _ref3 : undefined;
  var ref = register(name, validation);
  return {
    control: control,
    error: error,
    isDisabled: isDisabled,
    /**
     * Keep track of the first error in this form.
     * This is so we only add the correct aria-live props on the first error.
     */
    isFirstError: Object.keys(errors)[0] === name,
    isLoading: isLoading,
    isRequired: !!(validation !== null && validation !== void 0 && validation.required),
    register: register,
    validation: validation,
    ref: ref,
    setValue: setValue,
    setError: setError,
    showRequired: showRequired
  };
};
export var useSubmitState = function useSubmitState(_ref4) {
  var loading = _ref4.loading,
    disabled = _ref4.disabled;
  var _useFormContext2 = useFormContext(),
    formState = _useFormContext2.formState;
  var isLoading = typeof loading === 'function' ? loading(formState) : loading;
  var isDisabled = typeof disabled === 'function' ? disabled(formState) : disabled === undefined ? formState.isValid : disabled;
  return {
    isLoading: isLoading,
    isDisabled: isDisabled
  };
};
export var useGetInitialFormValue = function useGetInitialFormValue(_ref5) {
  var name = _ref5.name,
    setLocalValue = _ref5.setLocalValue,
    watchUpdateKeyName = _ref5.watchUpdateKeyName,
    defaultValue = _ref5.defaultValue;
  var _useFormState2 = useFormState(),
    getValues = _useFormState2.getValues,
    watch = _useFormState2.watch,
    setValue = _useFormState2.setValue;
  /**
   * This ensures that the initialValue can be updated on subsequent re-renders
   * if necessary according to some larger update.
   *
   * For example, imagine a form that gets submitted, but stays on the form page
   * and should display with the "new" data that the user just saved. The form will
   * re-render because we re-populate it with the response data from our successful POST
   * but the original memoized value would appear instead of the "new" initial value.
   *
   * This key allows us to watch something like "updatedAt"
   * so that the initialValue will be re-synced when some larger context
   * about our form changes.
   */
  var updated = watchUpdateKeyName ? watch(watchUpdateKeyName) : undefined;

  // For some reason including `updated` trips a lint error about unnecessary deps
  // but it doesn't throw anything in the editor :shrug:
  // eslint-disable-next-line react-hooks/exhaustive-deps
  var initialValue = useMemo(function () {
    return getValues(name);
  }, [name, getValues, updated]);
  useEffect(function () {
    if (!(isNull(initialValue) || isUndefined(initialValue))) {
      setLocalValue(initialValue);
    } else {
      setValue(name, defaultValue);
    }
  }, [initialValue, defaultValue, name, setLocalValue, setValue]);
};
export var USE_DEBOUNCED_FIELD_DIRTY_KEY = '';

/**
 * @remarks
 * see https://github.com/react-hook-form/react-hook-form/discussions/4522
 *
 * This fn is used to solve a purely UX issue rather than a functional one:
 * Imagine a user who begins typing in an input but notices that the
 * dirty state on the form hasn't changed (maybe a "Save" button doesn't light up).
 * Because we're actually only updating our form onBlur, the dirty state of the form
 * won't change until onBlur occurs as well, but that's counter-intuitive to users.
 *
 * This fn dirties the form as soon as they begin typing
 * (by being called as part of the onChange fn of the input) by
 * setting the value to some non-key ('') to a non-undefined / non-null state.
 *
 * This is very hacky, but in our testing we couldn't find any problems with it.
 */
var useMakeSetFormDirty = function useMakeSetFormDirty(shouldDirtyOnChange) {
  var _useFormState3 = useFormState(),
    isDirty = _useFormState3.isDirty,
    setValue = _useFormState3.setValue;
  return function () {
    if (shouldDirtyOnChange && !isDirty) {
      setValue(USE_DEBOUNCED_FIELD_DIRTY_KEY, '', {
        shouldDirty: true
      });
    }
  };
};

/**
 * The HTMLInputTypeAttribute type includes
 * (string | {}) which is a "hack" that allows ts autocomplete
 * to suggest the actual input types while also accepting any random string.
 * However, this type breaks down the overall type for the `type` prop below
 * due to it being passed through a few layers of <T extends ...>
 * and it ends up just being a string with no autocomplete.
 *
 * I'm extracting the relevant, usable types here from HTMLInputTypeAttribute
 * but would love to figure out a programatic solution.
 *
 * See https://github.com/Microsoft/TypeScript/issues/12215#issuecomment-414783301
 * for something that I think could be modified to make this better
 * but I couldn't get it to work
 */

export function useDebouncedField(_ref6) {
  var name = _ref6.name,
    watchUpdateKeyName = _ref6.watchUpdateKeyName,
    disabled = _ref6.disabled,
    loading = _ref6.loading,
    type = _ref6.type,
    shouldDirtyOnChange = _ref6.shouldDirtyOnChange;
  var useFieldPayload = useField({
    name: name,
    disabled: disabled,
    loading: loading
  });
  var defaultValue = type === 'checkbox' ? false : '';

  // START - Specific to useDebouncedField - START
  var _useState = useState(defaultValue),
    _useState2 = _slicedToArray(_useState, 2),
    localValue = _useState2[0],
    setLocalValue = _useState2[1];
  useGetInitialFormValue({
    name: name,
    setLocalValue: setLocalValue,
    watchUpdateKeyName: watchUpdateKeyName,
    defaultValue: defaultValue
  });
  var setFormDirty = useMakeSetFormDirty(shouldDirtyOnChange);
  var onChange = function onChange(e) {
    // Per React Hook Form
    // these are the only two relevant Event value options
    // See https://github.dev/react-hook-form/react-hook-form/blob/f52f2ddbdd13d968926765408ac734a2a42cad2a/src/logic/getEventValue.ts#L6
    setLocalValue(type === 'checkbox' ? e.target.checked : e.target.value);
    setFormDirty();
  };
  var onBlur = function onBlur() {
    return useFieldPayload.setValue(name, localValue, {
      shouldDirty: !shouldDirtyOnChange
    });
  };
  // END - Specific to useDebouncedField - END

  return _objectSpread(_objectSpread({}, omit(useFieldPayload, ['register', 'setValue'])), {}, {
    onBlur: onBlur,
    onChange: onChange,
    value: localValue
  });
}