import { MiniChevronDownIcon } from '@codecademy/gamut-icons';
import * as React from 'react';
import { Rotation } from '../../Animation';
import { FlexBox } from '../../Box/FlexBox';
import { TextButton } from '../../Button/TextButton';
import { jsx as _jsx } from "react/jsx-runtime";
export var ExpandControl = function ExpandControl(_ref) {
  var id = _ref.id,
    disabled = _ref.disabled,
    expanded = _ref.expanded,
    onExpand = _ref.onExpand;
  return /*#__PURE__*/_jsx(FlexBox, {
    mt: {
      _: 8,
      xs: 0
    },
    pl: {
      _: 0,
      xs: 16
    },
    width: 1,
    center: true,
    children: /*#__PURE__*/_jsx(TextButton, {
      disabled: disabled,
      variant: "secondary",
      width: {
        _: 1,
        xs: 32
      },
      size: "small",
      onClick: function onClick() {
        onExpand === null || onExpand === void 0 ? void 0 : onExpand({
          rowId: id,
          toggle: expanded
        });
      },
      "aria-label": "Expand ".concat(id, " Row"),
      "aria-expanded": expanded,
      children: /*#__PURE__*/_jsx(Rotation, {
        rotated: expanded,
        children: /*#__PURE__*/_jsx(MiniChevronDownIcon, {
          color: "text-disabled"
        })
      })
    })
  });
};