import { ComponentProps } from 'react';
import { List } from '../List';
import { DataListControls, IdentifiableKeys } from '.';
import { MarshaledColProps } from './Rows/Row';
import { ColumnConfig } from './types';
export interface DataGridProps<Row, IdKey extends IdentifiableKeys<Row>, Cols extends ColumnConfig<Row>[]> extends MarshaledColProps, DataListControls<Row, IdKey, Cols>, Omit<ComponentProps<typeof List>, 'header' | 'id'> {
    /** Whether the data inside is loading and should be indicated to the user somehow */
    loading?: boolean;
    /** Whether an additional header element should be added */
    header?: boolean;
    /** Whether Select All checkmark should be hidden in the header. Defaults to false */
    hideSelectAll?: boolean;
}
export declare function DataGrid<Row, IdKey extends IdentifiableKeys<Row>, Cols extends ColumnConfig<Row>[]>(props: DataGridProps<Row, IdKey, Cols>): JSX.Element;
