function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { useMemo } from 'react';
import { List } from '../List';
import { EmptyRows } from './EmptyRows';
import { ListControlContext, useListControls } from './hooks/useListControls';
import { ListStateContext } from './hooks/useListState';
import { HeaderRow } from './Rows/HeaderRow';
import { DataRow } from './Rows/Row';
import { jsx as _jsx } from "react/jsx-runtime";
export function DataGrid(props) {
  var listControls = useListControls(props);
  var _props$variant = props.variant,
    variant = _props$variant === void 0 ? 'table' : _props$variant,
    _props$spacing = props.spacing,
    spacing = _props$spacing === void 0 ? 'condensed' : _props$spacing,
    _props$scrollable = props.scrollable,
    scrollable = _props$scrollable === void 0 ? true : _props$scrollable,
    _props$shadow = props.shadow,
    shadow = _props$shadow === void 0 ? false : _props$shadow,
    _props$height = props.height,
    height = _props$height === void 0 ? scrollable ? '100%' : 'initial' : _props$height,
    columns = props.columns,
    idKey = props.idKey,
    rows = props.rows,
    selected = props.selected,
    expanded = props.expanded,
    query = props.query,
    loading = props.loading,
    _props$minHeight = props.minHeight,
    minHeight = _props$minHeight === void 0 ? 0 : _props$minHeight,
    _props$header = props.header,
    header = _props$header === void 0 ? true : _props$header,
    showOverflow = props.showOverflow,
    emptyMessage = props.emptyMessage,
    _props$hideSelectAll = props.hideSelectAll,
    hideSelectAll = _props$hideSelectAll === void 0 ? false : _props$hideSelectAll,
    _props$scrollToTopOnU = props.scrollToTopOnUpdate,
    scrollToTopOnUpdate = _props$scrollToTopOnU === void 0 ? false : _props$scrollToTopOnU,
    rest = _objectWithoutProperties(props, ["variant", "spacing", "scrollable", "shadow", "height", "columns", "idKey", "rows", "selected", "expanded", "query", "loading", "minHeight", "header", "showOverflow", "emptyMessage", "hideSelectAll", "scrollToTopOnUpdate"]);
  var empty = rows.length === 0;
  var allSelected = useMemo(function () {
    if (empty) return false;
    var ids = rows.map(function (_ref) {
      var id = _ref[idKey];
      return id;
    });
    var unselected = ids.filter(function (id) {
      return !(selected !== null && selected !== void 0 && selected.includes(id));
    });
    return unselected.length === 0;
  }, [rows, selected, idKey, empty]);
  var selectedRows = useMemo(function () {
    return selected === null || selected === void 0 ? void 0 : selected.reduce(function (carry, next) {
      return _objectSpread(_objectSpread({}, carry), {}, _defineProperty({}, String(next), true));
    }, {});
  }, [selected]);
  var expandedRows = useMemo(function () {
    return expanded === null || expanded === void 0 ? void 0 : expanded.reduce(function (carry, next) {
      return _objectSpread(_objectSpread({}, carry), {}, _defineProperty({}, String(next), true));
    }, {});
  }, [expanded]);
  var loadingRows = useMemo(function () {
    var loadingRow = {};
    columns.forEach(function (elem) {
      var key = elem.key;
      loadingRow[key] = '';
    });
    var placeholderRows = Array(5).fill(loadingRow, 0).map(function (elem, index) {
      return _objectSpread(_objectSpread({}, elem), {}, _defineProperty({}, idKey, "loading-".concat(index)));
    });
    return placeholderRows;
  }, [columns, idKey]);
  var renderedRows = loading && empty ? loadingRows : rows;
  return /*#__PURE__*/_jsx(ListStateContext.Provider, {
    value: {
      query: query
    },
    children: /*#__PURE__*/_jsx(ListControlContext.Provider, {
      value: listControls,
      children: /*#__PURE__*/_jsx(List, _objectSpread(_objectSpread({}, rest), {}, {
        emptyMessage: emptyMessage !== null && emptyMessage !== void 0 ? emptyMessage : /*#__PURE__*/_jsx(EmptyRows, {}),
        header: header ? /*#__PURE__*/_jsx(HeaderRow, {
          columns: columns,
          selected: allSelected,
          empty: empty,
          hideSelectAll: hideSelectAll
        }) : null,
        height: height,
        minHeight: minHeight,
        scrollable: scrollable,
        scrollToTopOnUpdate: scrollToTopOnUpdate,
        shadow: shadow,
        spacing: spacing,
        variant: variant,
        children: renderedRows.map(function (row) {
          var rowId = row[idKey];
          var key = listControls.prefixId("".concat(rowId, "-row"));
          return /*#__PURE__*/_jsx(DataRow, {
            id: rowId,
            row: row,
            columns: columns,
            selected: selectedRows === null || selectedRows === void 0 ? void 0 : selectedRows[rowId],
            expanded: expandedRows === null || expandedRows === void 0 ? void 0 : expandedRows[rowId],
            loading: loading,
            showOverflow: showOverflow
          }, key);
        })
      }))
    })
  });
}