function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { memo } from 'react';
import { FlexBox } from '../..';
import { ListCol, ListHeader } from '../../List';
import { ExpandControl, FilterControl, SelectControl, SortControl } from '../Controls';
import { useControlContext } from '../hooks/useListControls';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";
export var Header = function Header(_ref) {
  var columns = _ref.columns,
    _ref$selected = _ref.selected,
    selected = _ref$selected === void 0 ? false : _ref$selected,
    _ref$empty = _ref.empty,
    empty = _ref$empty === void 0 ? false : _ref$empty,
    hideSelectAll = _ref.hideSelectAll;
  var _useControlContext = useControlContext(),
    expandable = _useControlContext.expandable,
    selectable = _useControlContext.selectable,
    onSelect = _useControlContext.onSelect,
    onFilter = _useControlContext.onFilter,
    onSort = _useControlContext.onSort,
    prefixId = _useControlContext.prefixId;
  return /*#__PURE__*/_jsx(ListHeader, {
    children: /*#__PURE__*/_jsxs(_Fragment, {
      children: [selectable && /*#__PURE__*/_jsx(ListCol, {
        size: "content",
        children: !hideSelectAll && /*#__PURE__*/_jsx(SelectControl, {
          disabled: empty,
          rowId: "header",
          name: prefixId('all'),
          label: "Select All",
          onSelect: onSelect,
          selected: selected
        })
      }), columns.map(function (_ref2) {
        var key = _ref2.key,
          header = _ref2.header,
          sortable = _ref2.sortable,
          filters = _ref2.filters,
          colProps = _objectWithoutProperties(_ref2, ["key", "header", "sortable", "filters"]);
        var rowProperty = key;
        var renderKey = prefixId("header-col-".concat(rowProperty));
        var columnText = String(header || key);
        return /*#__PURE__*/_jsx(ListCol, _objectSpread(_objectSpread({}, colProps), {}, {
          columnHeader: true,
          children: /*#__PURE__*/_jsxs(FlexBox, {
            gap: 8,
            alignItems: "flex-end",
            width: "100%",
            children: [filters && /*#__PURE__*/_jsx(FilterControl, {
              columnKey: rowProperty,
              onFilter: onFilter,
              options: filters,
              justify: colProps.justify
            }), sortable ? /*#__PURE__*/_jsx(SortControl, {
              columnKey: rowProperty,
              onSort: onSort,
              children: columnText
            }) : columnText]
          })
        }), renderKey);
      }), expandable && /*#__PURE__*/_jsx(ListCol, {
        size: "content",
        ghost: true,
        children: /*#__PURE__*/_jsx(ExpandControl, {})
      })]
    })
  });
};
export var HeaderRow = /*#__PURE__*/memo(Header);