function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import { memo, useCallback } from 'react';
import { Text } from '../..';
import { ListCol, ListRow } from '../../List';
import { Shimmer } from '../../Loading/Shimmer';
import { ExpandControl, SelectControl } from '../Controls';
import { useControlContext } from '../hooks/useListControls';
import { jsx as _jsx } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export var Row = function Row(_ref) {
  var id = _ref.id,
    columns = _ref.columns,
    row = _ref.row,
    _ref$expanded = _ref.expanded,
    expanded = _ref$expanded === void 0 ? false : _ref$expanded,
    _ref$selected = _ref.selected,
    selected = _ref$selected === void 0 ? false : _ref$selected,
    _ref$loading = _ref.loading,
    loading = _ref$loading === void 0 ? false : _ref$loading,
    showOverflow = _ref.showOverflow;
  var _useControlContext = useControlContext(),
    expandable = _useControlContext.expandable,
    selectable = _useControlContext.selectable,
    expandedContent = _useControlContext.expandedContent,
    onExpand = _useControlContext.onExpand,
    onSelect = _useControlContext.onSelect,
    prefixId = _useControlContext.prefixId;
  var listColProps = {
    showOverflow: showOverflow
  };
  var renderExpandedContent = useCallback(function () {
    return expandedContent === null || expandedContent === void 0 ? void 0 : expandedContent({
      row: row,
      onCollapse: function onCollapse() {
        return onExpand({
          rowId: id,
          toggle: true
        });
      }
    });
  }, [onExpand, expandedContent, id, row]);
  return /*#__PURE__*/_jsxs(ListRow, {
    expanded: expanded,
    renderExpanded: renderExpandedContent,
    children: [selectable && /*#__PURE__*/_jsx(ListCol, _objectSpread(_objectSpread({}, listColProps), {}, {
      display: {
        _: 'flex',
        xs: 'flex'
      },
      size: "content",
      type: "control",
      children: /*#__PURE__*/_jsx(SelectControl, {
        disabled: loading,
        label: "Select ".concat(id),
        name: prefixId(String(id)),
        rowId: String(id),
        selected: selected,
        onSelect: onSelect
      })
    })), columns.map(function (_ref2) {
      var key = _ref2.key,
        render = _ref2.render,
        size = _ref2.size,
        justify = _ref2.justify,
        fill = _ref2.fill,
        type = _ref2.type;
      var colProps = _objectSpread(_objectSpread({}, listColProps), {}, {
        size: size,
        justify: justify,
        fill: fill,
        type: type,
        key: prefixId("".concat(id, "-col-").concat(String(key)))
      });
      if (loading) {
        return /*#__PURE__*/_jsx(ListCol, _objectSpread(_objectSpread({}, colProps), {}, {
          children: /*#__PURE__*/_jsx(Shimmer, {
            minHeight: 24,
            height: "calc(100% - 1rem)",
            width: "calc(100% - 0.5rem)"
          })
        }));
      }
      return /*#__PURE__*/_jsx(ListCol, _objectSpread(_objectSpread({}, colProps), {}, {
        children: /*#__PURE__*/_jsx(_Fragment, {
          children: render ? render(row) : typeof row[key] === 'string' ? /*#__PURE__*/_jsx(Text, {
            truncate: "ellipsis",
            truncateLines: 1,
            textAlign: justify !== null && justify !== void 0 ? justify : 'left',
            children: row[key]
          }) : row[key]
        })
      }));
    }), expandable && /*#__PURE__*/_jsx(ListCol, _objectSpread(_objectSpread({}, listColProps), {}, {
      size: "content",
      order: [1000, 'initial'],
      children: /*#__PURE__*/_jsx(ExpandControl, {
        id: id,
        expanded: expanded,
        onExpand: onExpand,
        disabled: loading
      })
    }))]
  });
};
export var DataRow = /*#__PURE__*/memo(Row);