/// <reference types="react" />
import { ColumnConfig, DataListControls, ExpandRow, IdentifiableKeys, OnFilter, OnSort, RowChange } from '..';
export declare function useListControls<Row, IdKey extends IdentifiableKeys<Row>, Cols extends ColumnConfig<Row>[]>({ idKey, id, onQueryChange, onRowExpand, onRowSelect, expandedContent, }: DataListControls<Row, IdKey, Cols>): {
    idKey: IdKey;
    prefixId: <T extends string | number | symbol>(affix: T) => string;
    onSelect: RowChange<Row[IdKey]>;
    onExpand: RowChange<Row[IdKey]>;
    onFilter: OnFilter<Row>;
    onResetQuery: () => void;
    onSort: OnSort<Row>;
    expandedContent: ExpandRow<Row> | undefined;
    expandable: boolean;
    selectable: boolean;
};
interface Controls {
    idKey: any;
    expandedContent?: ExpandRow<any>;
    prefixId: <T extends keyof any>(affix: T) => string;
    onFilter: OnFilter<any>;
    onSort: OnSort<any>;
    onResetQuery: () => void;
    onSelect: RowChange<any>;
    onExpand: RowChange<any>;
    expandable: boolean;
    selectable: boolean;
}
export declare const ListControlContext: import("react").Context<Controls>;
export declare const useControlContext: () => Controls;
export {};
