import { ColumnConfig, IdentifiableKeys, OnQueryChange, Query } from '..';
export interface LocalQueryShape<Row, IdKey extends IdentifiableKeys<Row>, Cols extends ColumnConfig<Row>[]> {
    rows: Row[];
    idKey: IdKey;
    columns: Cols;
}
export declare const useLocalQuery: <Row, Cols extends ColumnConfig<Row>[], IdKey extends IdentifiableKeys<Row>>({ idKey, rows, }: LocalQueryShape<Row, IdKey, Cols>) => {
    idKey: IdKey;
    query: Query<Row>;
    rows: Row[];
    onQueryChange: OnQueryChange<Row>;
};
