import { Colors } from '@codecademy/gamut-styles';
import * as React from 'react';
import { WithChildrenProp } from '..';
export interface FlyoutProps extends WithChildrenProp {
    /**
     * Accessibility label for the close button.
     */
    closeLabel: string;
    /**
     * Whether the flyout should be open.
     */
    expanded?: boolean;
    /**
     * Called by the Flyout to close itself.
     */
    onClose: () => void;
    /**
     * Which direction of the screen this flies out from.
     */
    openFrom?: 'left' | 'right';
    /**
     * Contents for a top-left h2.
     */
    title: React.ReactNode;
    bg?: Colors;
}
export declare const Flyout: React.FC<FlyoutProps>;
