import { StyleProps } from '@codecademy/variance';
import { HTMLAttributes } from 'react';
import * as React from 'react';
import { ToolTipProps } from '../ToolTip';
declare const labelSizeVariants: (props: import("@codecademy/variance/dist/types/config").VariantProps<"size", false | "small" | "large"> & {
    theme?: import("@emotion/react").Theme | undefined;
}) => import("@codecademy/variance").CSSObject;
declare const labelPaddingVariants: (props: import("@codecademy/variance/dist/types/config").VariantProps<"tooltipPadding", false | "right-align" | "left-align"> & {
    theme?: import("@emotion/react").Theme | undefined;
}) => import("@codecademy/variance").CSSObject;
declare const labelStates: (props: Partial<Record<"disabled", boolean>> & {
    theme?: import("@emotion/react").Theme | undefined;
}) => import("@codecademy/variance").CSSObject;
export interface LabelVariants extends StyleProps<typeof labelSizeVariants>, StyleProps<typeof labelPaddingVariants>, StyleProps<typeof labelStates> {
}
export type FormToolTipProps = ToolTipProps & {
    position?: 'left-align' | 'right-align';
};
export type FormGroupLabelProps = HTMLAttributes<HTMLDivElement> & HTMLAttributes<HTMLLabelElement> & LabelVariants & {
    /**
     * [The for/id string of a label or labelable form-related element](https://developer.mozilla.org/en-US/docs/Web/API/HTMLLabelElement/htmlFor). The outer FormGroup or FormLabel should have an identical string as the inner FormElement for accessibility purposes.
     */
    htmlFor?: string;
    tooltip?: ToolTipProps;
    showRequired?: boolean;
    size?: 'small' | 'large';
};
export declare const FormGroupLabel: React.FC<FormGroupLabelProps>;
export {};
