import { StyleProps } from '@codecademy/variance';
import { SelectHTMLAttributes } from 'react';
import { conditionalStyles } from './styles';
export type SelectOptions = string[] | Record<string, number | string>;
export type SelectComponentProps = Pick<SelectHTMLAttributes<HTMLSelectElement>, 'disabled' | 'id'> & {
    error?: boolean;
    htmlFor?: string;
    options?: SelectOptions;
};
export type SelectWrapperProps = SelectComponentProps & SelectHTMLAttributes<HTMLSelectElement> & {
    sizeVariant?: 'small' | 'base';
};
export interface SelectProps extends SelectWrapperProps, StyleProps<typeof conditionalStyles> {
}
export declare const Select: import("react").ForwardRefExoticComponent<Pick<SelectHTMLAttributes<HTMLSelectElement>, "id" | "disabled"> & {
    error?: boolean | undefined;
    htmlFor?: string | undefined;
    options?: SelectOptions | undefined;
} & SelectHTMLAttributes<HTMLSelectElement> & {
    sizeVariant?: "base" | "small" | undefined;
} & import("react").RefAttributes<HTMLSelectElement>>;
