function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0) { ; } } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { useTheme } from '@emotion/react';
import { useId } from '@reach/auto-id';
import { useCallback, useEffect, useMemo, useRef, useState } from 'react';
import * as React from 'react';
import { getMemoizedStyles } from '../styles';
import { parseOptions } from '../utils';
import { CustomContainer, DropdownButton, formatGroupLabel, formatOptionLabel, MultiValueRemoveButton, MultiValueWithColorMode, onFocus, RemoveAllButton, SelectDropdownContext, TypedReactSelect } from './elements';
import { filterValueFromOptions, isMultipleSelectProps, isOptionGroup, isSingleSelectProps, removeValueFromSelectedOptions } from './utils';
import { jsx as _jsx } from "react/jsx-runtime";
var defaultProps = {
  name: undefined,
  components: {
    DropdownIndicator: DropdownButton,
    IndicatorSeparator: function IndicatorSeparator() {
      return null;
    },
    ClearIndicator: RemoveAllButton,
    SelectContainer: CustomContainer,
    MultiValue: MultiValueWithColorMode,
    MultiValueRemove: MultiValueRemoveButton
  }
};
var onChangeAction = 'select-option';
export var SelectDropdown = function SelectDropdown(_ref) {
  var options = _ref.options,
    id = _ref.id,
    size = _ref.size,
    error = _ref.error,
    disabled = _ref.disabled,
    onChange = _ref.onChange,
    value = _ref.value,
    name = _ref.name,
    _ref$placeholder = _ref.placeholder,
    placeholder = _ref$placeholder === void 0 ? 'Select an option' : _ref$placeholder,
    inputProps = _ref.inputProps,
    multiple = _ref.multiple,
    _ref$isSearchable = _ref.isSearchable,
    isSearchable = _ref$isSearchable === void 0 ? false : _ref$isSearchable,
    _ref$shownOptionsLimi = _ref.shownOptionsLimit,
    shownOptionsLimit = _ref$shownOptionsLimi === void 0 ? 6 : _ref$shownOptionsLimi,
    rest = _objectWithoutProperties(_ref, ["options", "id", "size", "error", "disabled", "onChange", "value", "name", "placeholder", "inputProps", "multiple", "isSearchable", "shownOptionsLimit"]);
  var rawInputId = useId();
  var inputId = name !== null && name !== void 0 ? name : "".concat(id, "-select-dropdown-").concat(rawInputId);
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    activated = _useState2[0],
    setActivated = _useState2[1];
  var _useState3 = useState(undefined),
    _useState4 = _slicedToArray(_useState3, 2),
    currentFocusedValue = _useState4[0],
    setCurrentFocusedValue = _useState4[1]; // these are used to programatically manage the focus state of our multi-select options + 'Remove all' button
  var removeAllButtonRef = useRef(null);
  var selectInputRef = useRef(null);
  var optionsAreGrouped = useMemo(function () {
    if (options !== null && options !== void 0 && options.length) {
      return options === null || options === void 0 ? void 0 : options.some(function (option) {
        return isOptionGroup(option);
      });
    }
    return false;
  }, [options]);
  var selectOptions = useMemo(function () {
    return parseOptions({
      options: options,
      id: id,
      size: size
    });
  }, [options, id, size]);
  var parsedValue = useMemo(function () {
    return selectOptions.find(function (option) {
      return option.value === value;
    });
  }, [selectOptions, value]);
  var _useState5 = useState(multiple &&
    // To keep this efficient for non-multiSelect
    filterValueFromOptions(selectOptions, value, optionsAreGrouped)),
    _useState6 = _slicedToArray(_useState5, 2),
    multiValues = _useState6[0],
    setMultiValues = _useState6[1]; // If the caller changes the initial value, let's update our value to match.
  useEffect(function () {
    var newMultiValues = filterValueFromOptions(selectOptions, value, optionsAreGrouped);
    if (newMultiValues !== multiValues) setMultiValues(newMultiValues);

    // For now, only handle the "change the value" case.
    // Changing the options can be looked into when this component is fleshed out (GM-354)
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [value]);
  var changeHandler = useCallback(function (optionEvent) {
    setActivated(true);

    // We have to do this because the version of typescript we have doesn't have the transitivity of these type guards yet. But, we will soon!
    // Should probably come with: https://codecademy.atlassian.net/browse/GM-354
    var onChangeProps = {
      onChange: onChange,
      multiple: multiple
    };
    if (isSingleSelectProps(onChangeProps)) {
      var _onChangeProps$onChan;
      var singleOptionEvent = optionEvent;
      (_onChangeProps$onChan = onChangeProps.onChange) === null || _onChangeProps$onChan === void 0 ? void 0 : _onChangeProps$onChan.call(onChangeProps, singleOptionEvent, {
        action: onChangeAction,
        option: singleOptionEvent
      });
    }
    if (isMultipleSelectProps(onChangeProps)) {
      var _onChangeProps$onChan2;
      setMultiValues(optionEvent);
      (_onChangeProps$onChan2 = onChangeProps.onChange) === null || _onChangeProps$onChan2 === void 0 ? void 0 : _onChangeProps$onChan2.call(onChangeProps, optionEvent, {
        action: onChangeAction,
        option: undefined // At the moment this isn't used, but when multi select is built for real, boom (https://codecademy.atlassian.net/browse/GM-354)
      });
    }
  }, [onChange, multiple]);
  var keyPressHandler = function keyPressHandler(e) {
    if (multiple && e.key === 'Enter' && currentFocusedValue && multiValues) {
      var newMultiValues = removeValueFromSelectedOptions(multiValues, currentFocusedValue);
      if (newMultiValues !== multiValues) setMultiValues(newMultiValues);
    }
    if (removeAllButtonRef.current !== null && e.key === 'ArrowRight' && multiValues && currentFocusedValue === multiValues[multiValues.length - 1].value) {
      removeAllButtonRef.current.focus();
    }
  };
  var theme = useTheme();
  var memoizedStyles = useMemo(function () {
    return getMemoizedStyles(theme);
  }, [theme]);
  return /*#__PURE__*/_jsx(SelectDropdownContext.Provider, {
    value: {
      currentFocusedValue: currentFocusedValue,
      setCurrentFocusedValue: setCurrentFocusedValue,
      removeAllButtonRef: removeAllButtonRef,
      selectInputRef: selectInputRef
    },
    children: /*#__PURE__*/_jsx(TypedReactSelect, _objectSpread(_objectSpread({}, defaultProps), {}, {
      activated: activated,
      error: Boolean(error),
      ariaLiveMessages: {
        onFocus: onFocus
      },
      formatGroupLabel: formatGroupLabel,
      formatOptionLabel: formatOptionLabel,
      id: id || rest.htmlFor || rawInputId,
      inputId: inputId,
      inputProps: _objectSpread(_objectSpread({}, inputProps), {}, {
        name: name
      }),
      isDisabled: disabled,
      isMulti: multiple,
      isOptionDisabled: function isOptionDisabled(option) {
        return option.disabled;
      },
      isSearchable: isSearchable,
      name: name,
      onChange: changeHandler,
      onKeyDown: multiple ? function (e) {
        return keyPressHandler(e);
      } : undefined,
      options: selectOptions,
      placeholder: placeholder,
      shownOptionsLimit: shownOptionsLimit,
      size: size,
      styles: memoizedStyles,
      value: multiple ? multiValues : parsedValue,
      selectRef: selectInputRef
    }, rest))
  });
};