/// <reference types="react" />
import { AriaOnFocus, GroupBase, MultiValueProps, MultiValueRemoveProps, Props } from 'react-select';
import { CustomContainerProps, ExtendedOption, SelectDropdownContextValueTypes, SelectDropdownGroup, SizedIndicatorProps, TypedReactSelectProps } from './types';
export declare const SelectDropdownContext: import("react").Context<SelectDropdownContextValueTypes>;
export declare const MultiValueWithColorMode: (props: MultiValueProps) => JSX.Element;
export declare const MultiValueRemoveButton: (props: MultiValueRemoveProps) => JSX.Element;
export declare const DropdownButton: (props: SizedIndicatorProps) => JSX.Element;
export declare const RemoveAllButton: (props: SizedIndicatorProps) => JSX.Element;
export declare const CustomContainer: ({ children, ...rest }: CustomContainerProps) => JSX.Element;
export declare const formatOptionLabel: ({ label, icon: Icon, size, subtitle, rightLabel, disabled, }: ExtendedOption) => JSX.Element;
export declare const formatGroupLabel: ({ label, divider }: SelectDropdownGroup) => string | JSX.Element | undefined;
export declare function TypedReactSelect<OptionType, IsMulti extends boolean = false, GroupType extends GroupBase<OptionType> = GroupBase<OptionType>>({ selectRef, ...props }: Props<OptionType, IsMulti, GroupType> & TypedReactSelectProps): JSX.Element;
export declare const onFocus: AriaOnFocus<ExtendedOption>;
