function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import { css, states, variant } from '@codecademy/gamut-styles';
import { dismissSharedStyles, tagBaseStyles, tagBorderRadius, tagLabelFontSize, tagLabelPadding } from '../../Tag/styles';
import { formBaseComponentStyles, formBaseFieldStylesObject, formFieldDisabledStyles, formFieldPaddingStyles, InputSelectors } from '../styles';
var selectDropdownStyles = css(_objectSpread(_objectSpread({}, formBaseFieldStylesObject), {}, {
  display: 'flex',
  zIndex: 3
}));
var selectFocusStyles = {
  color: 'primary',
  borderColor: 'currentColor',
  boxShadow: "inset 0 0 0 1px currentColor"
};
export var conditionalBorderStates = states({
  isFocused: selectFocusStyles,
  activated: {
    borderColor: 'currentColor'
  },
  error: _defineProperty({
    color: 'feedback-error',
    borderColor: 'currentColor'
  }, InputSelectors.HOVER, {
    borderColor: 'currentColor'
  }),
  isDisabled: formFieldDisabledStyles
});
var sizeVariants = variant({
  prop: 'size',
  defaultVariant: 'medium',
  variants: {
    medium: formFieldPaddingStyles,
    mediumIsMultiSelected: {
      px: 8,
      py: 8
    },
    small: {
      height: '2rem',
      px: 8,
      py: 0
    }
  }
});
var dropdownBorderStates = states({
  error: {
    borderColorTop: 'feedback-error'
  }
});
var dropdownBorderStyles = css(_objectSpread(_objectSpread({}, formBaseComponentStyles), {}, {
  border: 1,
  borderColor: 'currentColor',
  position: 'absolute',
  marginTop: 0,
  borderRadius: 0,
  zIndex: 2
}));
var getOptionBackground = function getOptionBackground(isSelected, isFocused) {
  return css({
    bg: isFocused ? 'background-hover' : isSelected ? 'background-selected' : 'transparent'
  });
};
var textColor = css({
  color: 'text'
});
var placeholderColor = css({
  color: 'text-disabled'
});
export var getMemoizedStyles = function getMemoizedStyles(theme) {
  return {
    clearIndicator: function clearIndicator(provided) {
      return _objectSpread({}, provided);
    },
    container: function container(provided, state) {
      return _objectSpread(_objectSpread({}, provided), {}, {
        pointerEvents: 'visible',
        cursor: state.selectProps.isSearchable ? 'text' : 'pointer',
        width: '100%',
        minWidth: '7rem'
      });
    },
    control: function control(provided, state) {
      var _state$selectProps = state.selectProps,
        isMulti = _state$selectProps.isMulti,
        size = _state$selectProps.size;
      var getSize = size !== null && size !== void 0 ? size : 'medium';
      var getPadding = isMulti && state.hasValue && size !== 'small' ? "mediumIsMultiSelected" : getSize;
      return _objectSpread(_objectSpread(_objectSpread({}, selectDropdownStyles({
        theme: theme
      })), sizeVariants({
        size: getPadding,
        theme: theme
      })), conditionalBorderStates({
        isFocused: state.isFocused,
        isDisabled: state.isDisabled,
        error: state.selectProps.error,
        activated: state.selectProps.activated,
        theme: theme
      }));
    },
    dropdownIndicator: function dropdownIndicator() {
      return {
        color: 'currentColor',
        display: 'flex',
        padding: '0',
        pointerEvents: 'none'
      };
    },
    input: function input(provided) {
      return _objectSpread(_objectSpread(_objectSpread({}, provided), textColor({
        theme: theme
      })), {}, {
        padding: '0',
        margin: '0'
      });
    },
    menu: function menu(provided, state) {
      return _objectSpread(_objectSpread(_objectSpread({}, provided), dropdownBorderStyles({
        theme: theme
      })), dropdownBorderStates({
        error: state.selectProps.error,
        theme: theme
      }));
    },
    menuList: function menuList(provided, state) {
      var sizeInteger = state.selectProps.size === 'small' ? 2 : 3;
      var maxHeight = "".concat(state.selectProps.shownOptionsLimit * sizeInteger, "rem");
      return _objectSpread(_objectSpread({}, provided), {}, {
        maxHeight: maxHeight
      });
    },
    placeholder: function placeholder(provided) {
      return _objectSpread(_objectSpread({}, provided), placeholderColor({
        theme: theme
      }));
    },
    option: function option(provided, state) {
      return _objectSpread(_objectSpread({
        padding: state.selectProps.size === 'small' ? '3px 14px' : '11px 14px',
        cursor: state.isDisabled ? 'not-allowed' : 'pointer'
      }, getOptionBackground(state.isSelected, state.isFocused)({
        theme: theme
      })), {}, {
        display: 'flex',
        alignItems: 'center',
        color: state.isDisabled ? 'text-disabled' : 'default'
      });
    },
    singleValue: function singleValue(provided) {
      return _objectSpread(_objectSpread(_objectSpread({}, provided), textColor({
        theme: theme
      })), {}, {
        display: 'flex',
        alignItems: 'center',
        marginLeft: 0
      });
    },
    multiValue: function multiValue(provided) {
      return _objectSpread(_objectSpread(_objectSpread({}, provided), tagBaseStyles), {}, {
        cursor: 'pointer',
        background: theme.colors.background
      });
    },
    multiValueLabel: function multiValueLabel(provided) {
      return _objectSpread(_objectSpread({}, provided), {}, {
        fontSize: "".concat(tagLabelFontSize, "px"),
        color: theme.colors.text,
        borderRadius: tagBorderRadius,
        padding: "0 ".concat(tagLabelPadding, "px"),
        paddingLeft: "".concat(tagLabelPadding, "px") // default label has an explicit rule for padding left so we need this to override it
      });
    },

    multiValueRemove: function multiValueRemove(provided) {
      return _objectSpread(_objectSpread(_objectSpread({}, provided), dismissSharedStyles), {}, {
        cursor: 'pointer',
        borderRadius: "0px ".concat(tagBorderRadius, " ").concat(tagBorderRadius, " 0px"),
        // only want border radius on top and bottom right
        padding: 0,
        // default remove has padding left and right that we don't need
        ':hover': {
          backgroundColor: theme.colors['background-hover']
        }
      });
    },
    valueContainer: function valueContainer(provided) {
      return _objectSpread(_objectSpread({}, provided), {}, {
        padding: 0
      });
    }
  };
};