var _objectSpread2, _css, _base2;
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import { css, theme, timing, transitionConcat, variant } from '@codecademy/gamut-styles';
import { formBaseComponentStyles, formFieldBaseDisabledStyles, InputSelectors } from '.';
export var radioWrapper = css({
  margin: '0.25rem 0',
  width: '100%',
  fontWeight: 'normal'
});
var consistentLabelStyles = {
  content: '""',
  display: 'block',
  width: 20,
  height: 20,
  minWidth: 20,
  borderRadius: '100%',
  mr: 8
};
export var radioLabel = css(_objectSpread(_objectSpread({}, formBaseComponentStyles), {}, (_objectSpread2 = {
  bg: 'transparent',
  display: 'flex',
  py: 16,
  alignItems: 'center',
  cursor: 'pointer',
  position: 'relative'
}, _defineProperty(_objectSpread2, InputSelectors.BEFORE_AND_AFTER, consistentLabelStyles), _defineProperty(_objectSpread2, InputSelectors.BEFORE, {
  bg: 'background',
  boxShadow: "0 0 0 1px ".concat(theme.colors["text-disabled"]),
  transition: timing.medium
}), _defineProperty(_objectSpread2, InputSelectors.AFTER, {
  position: 'absolute',
  transition: transitionConcat(['transform'], 'medium', 'ease-in-out'),
  borderWidth: 5,
  borderStyle: 'solid',
  borderColor: 'background',
  transform: 'scale(0)'
}), _objectSpread2)));
export var radioInput = css((_css = {}, _defineProperty(_css, InputSelectors.CHECKED_AFTER, {
  bg: 'primary',
  borderWidth: 4,
  borderStyle: 'solid',
  borderColor: 'background',
  transform: 'scale(1)'
}), _defineProperty(_css, InputSelectors.CHECKED_BEFORE, {
  boxShadow: "0 0 0 1px ".concat(theme.colors.primary)
}), _defineProperty(_css, InputSelectors.HOVER_FOCUS_BEFORE, {
  boxShadow: "0 0 0 2px ".concat(theme.colors.primary)
}), _css));
export var conditionalRadioLabelStyles = variant({
  base: _defineProperty({}, InputSelectors.BEFORE, {
    boxShadow: "0 0 0 1px currentColor"
  }),
  variants: {
    error: _defineProperty({}, InputSelectors.BEFORE_AND_AFTER, {
      color: 'feedback-error'
    }),
    disabled: _objectSpread({}, formFieldBaseDisabledStyles)
  }
});
export var conditionalRadioInputStyles = variant({
  base: (_base2 = {}, _defineProperty(_base2, InputSelectors.CHECKED_AFTER, {
    bg: 'currentColor'
  }), _defineProperty(_base2, InputSelectors.CHECKED_BEFORE, {
    boxShadow: "0 0 0 1px currentColor"
  }), _base2),
  variants: {
    error: _defineProperty({}, InputSelectors.HOVER_FOCUS_BEFORE, {
      boxShadow: "0 0 0 2px currentColor"
    }),
    disabled: _objectSpread(_objectSpread({}, formFieldBaseDisabledStyles), {}, _defineProperty({}, InputSelectors.HOVER_FOCUS_BEFORE, {
      boxShadow: "0 0 0 1px currentColor"
    }))
  }
});