var _objectSpread3, _error;
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import { system, theme, transitionConcat } from '@codecademy/gamut-styles';
export var InputSelectors;
(function (InputSelectors) {
  InputSelectors["HOVER"] = "&:hover";
  InputSelectors["ACTIVE"] = "&:active";
  InputSelectors["PLACEHOLDER"] = "&:placeholder";
  InputSelectors["FOCUS"] = "&:focus";
  InputSelectors["FOCUS_LABEL_DIV_CHILD"] = "&:focus + label > div";
  InputSelectors["DISABLED"] = "&:disabled, &[aria-disabled='true']";
  InputSelectors["BEFORE"] = "&::before";
  InputSelectors["AFTER"] = "&::after";
  InputSelectors["BEFORE_AND_AFTER"] = "&::before, &::after";
  InputSelectors["CHECKED_BEFORE"] = "&:checked + label::before";
  InputSelectors["CHECKED_AFTER"] = "&:checked + label::after";
  InputSelectors["HOVER_FOCUS_BEFORE"] = "&:hover + label::before, &:focus + label::before";
})(InputSelectors || (InputSelectors = {}));
export var formBaseStyles = {
  fontWeight: 'base',
  fontSize: 16,
  color: 'text'
};
export var formBaseComponentStyles = _objectSpread({
  width: 1,
  outline: 'none',
  bg: 'background',
  minWidth: 'auto'
}, formBaseStyles);
export var formFieldFocusStyles = {
  borderColor: 'primary',
  boxShadow: "inset 0 0 0 1px ".concat(theme.colors.primary)
};
export var formFieldTextDisabledStyles = {
  color: 'text-disabled',
  cursor: 'not-allowed'
};
export var formFieldBaseDisabledStyles = _objectSpread({
  borderColor: 'currentColor',
  opacity: 1
}, formFieldTextDisabledStyles);
export var formFieldDisabledStyles = _objectSpread(_objectSpread({}, formFieldBaseDisabledStyles), {}, _defineProperty({
  bg: 'background-disabled'
}, InputSelectors.HOVER, {
  borderColor: 'currentColor'
}));
export var formFieldPaddingStyles = {
  py: 12,
  px: 8
};
export var formBaseFieldStylesObject = _objectSpread(_objectSpread({}, formBaseComponentStyles), {}, (_objectSpread3 = {
  transition: transitionConcat(['background-color', 'box-shadow'], 'slow', 'ease-in-out'),
  border: 1,
  borderColor: 'text-disabled',
  borderRadius: '2px'
}, _defineProperty(_objectSpread3, InputSelectors.HOVER, {
  borderColor: 'primary'
}), _defineProperty(_objectSpread3, InputSelectors.PLACEHOLDER, {
  borderColor: 'text-disabled',
  fontStyle: 'italic'
}), _defineProperty(_objectSpread3, InputSelectors.DISABLED, _objectSpread({}, formFieldDisabledStyles)), _objectSpread3));
export var formBaseFieldStyles = system.css(formBaseFieldStylesObject);
export var formFieldStyles = system.css(_objectSpread(_objectSpread(_objectSpread({}, formBaseFieldStylesObject), formFieldPaddingStyles), {}, _defineProperty({
  lineHeight: 'base'
}, InputSelectors.FOCUS, formFieldFocusStyles)));
export var conditionalStyles = system.variant({
  variants: {
    error: (_error = {
      borderColor: 'feedback-error'
    }, _defineProperty(_error, InputSelectors.HOVER, {
      borderColor: 'feedback-error'
    }), _defineProperty(_error, InputSelectors.FOCUS, {
      borderColor: 'feedback-error',
      boxShadow: "inset 0 0 0 1px ".concat(theme.colors['feedback-error'])
    }), _error),
    activated: {
      borderColor: 'currentColor'
    }
  }
});
export var conditionalStyleState = function conditionalStyleState(error, activated) {
  return error ? 'error' : activated ? 'activated' : undefined;
};