function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { Fragment } from 'react';
import * as React from 'react';
import { ConnectedForm } from '../ConnectedForm';
import { LayoutGrid } from '../Layout';
import { GridFormButtons } from './GridFormButtons';
import { GridFormContent, GridFormSection, GridFormSectionBreak, GridFormSectionTitle } from './GridFormSections';
import { assignDefaultValue } from './utils';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";
export * from './types';
var defaultColumnGap = {
  _: 8,
  sm: 32
};
var isGridFormSection = function isGridFormSection(field) {
  return field.title !== undefined;
};
export function GridForm(_ref) {
  var cancel = _ref.cancel,
    children = _ref.children,
    _ref$columnGap = _ref.columnGap,
    columnGap = _ref$columnGap === void 0 ? defaultColumnGap : _ref$columnGap,
    _ref$fields = _ref.fields,
    fields = _ref$fields === void 0 ? [] : _ref$fields,
    _ref$rowGap = _ref.rowGap,
    rowGap = _ref$rowGap === void 0 ? 16 : _ref$rowGap,
    submit = _ref.submit,
    _ref$validation = _ref.validation,
    validation = _ref$validation === void 0 ? 'onSubmit' : _ref$validation,
    _ref$showRequired = _ref.showRequired,
    showRequired = _ref$showRequired === void 0 ? false : _ref$showRequired,
    rest = _objectWithoutProperties(_ref, ["cancel", "children", "columnGap", "fields", "rowGap", "submit", "validation", "showRequired"]);
  var flatFields = fields.flatMap(function (field) {
    return isGridFormSection(field) ? field.fields : field;
  });
  var defaultValues = flatFields.reduce(
  // since our checkbox is a controlled input, it needs to be provided with a default value in order to reset correctly.
  function (defaultValues, field) {
    return _objectSpread(_objectSpread({}, defaultValues), {}, _defineProperty({}, field.name, field.defaultValue === undefined ? assignDefaultValue(field) : field.defaultValue));
  }, {});
  return /*#__PURE__*/_jsx(ConnectedForm, _objectSpread(_objectSpread({
    validation: validation,
    defaultValues: defaultValues,
    display: "flex",
    flexDirection: "column"
  }, rest), {}, {
    children: /*#__PURE__*/_jsxs(LayoutGrid, {
      columnGap: columnGap,
      rowGap: rowGap,
      children: [/*#__PURE__*/_jsx(_Fragment, {
        children: fields.map(function (field, index) {
          var numSections = fields.length;
          if (isGridFormSection(field)) {
            var title = field.title,
              as = field.as,
              layout = field.layout,
              _fields = field.fields,
              variant = field.variant;
            return /*#__PURE__*/_jsxs(Fragment, {
              children: [/*#__PURE__*/_jsx(GridFormSectionTitle, {
                title: title,
                as: as,
                layout: layout,
                numberOfFields: _fields.length,
                variant: variant
              }), /*#__PURE__*/_jsx(GridFormSection, {
                fields: _fields,
                showRequired: showRequired
              }), index + 1 === numSections ? null : /*#__PURE__*/_jsx(GridFormSectionBreak, {})]
            }, title);
          }
          return /*#__PURE__*/_jsx(GridFormContent, {
            field: field,
            showRequired: showRequired
          }, field.name);
        })
      }), /*#__PURE__*/_jsx(GridFormButtons, _objectSpread({
        cancel: cancel
      }, submit)), children]
    })
  }));
}