import { ColorModes } from '@codecademy/gamut-styles';
import { ComponentProps } from 'react';
import * as React from 'react';
import { ButtonProps } from '../../Button/shared';
import { SubmitButtonProps } from '../../ConnectedForm';
import { Column } from '../../Layout';
export type GridFormButtonsPosition = keyof typeof positions;
export type SubmitButtonType = keyof typeof buttonMap;
export type GridFormSubmitProps = {
    contents: React.ReactNode;
    position?: GridFormButtonsPosition;
    size: ComponentProps<typeof Column>['size'];
    disabled?: SubmitButtonProps['disabled'];
    loading?: SubmitButtonProps['loading'];
    mode?: ColorModes;
    type?: SubmitButtonType;
};
export type GridFormCancelButtonProps = {
    children: React.ReactNode;
    href?: 'string';
    onClick?: () => void;
};
type CancelButtonProps = {
    cancel?: ButtonProps;
};
declare const positions: {
    left: string;
    center: string;
    right: string;
    stretch: string;
};
declare const buttonMap: {
    cta: import("@emotion/styled").StyledComponent<Pick<any, string | number | symbol> & React.RefAttributes<HTMLAnchorElement | HTMLButtonElement> & {
        theme?: import("@emotion/react").Theme | undefined;
    } & ButtonProps & {
        variant?: "primary" | undefined;
    }, {}, {}>;
    fill: import("@emotion/styled").StyledComponent<Pick<any, string | number | symbol> & React.RefAttributes<HTMLAnchorElement | HTMLButtonElement> & {
        theme?: import("@emotion/react").Theme | undefined;
    } & ButtonProps, {}, {}>;
};
export declare const GridFormButtons: React.FC<GridFormSubmitProps & CancelButtonProps>;
export {};
