import * as React from 'react';
export type InputStepperButtonTargets = 'increase_selection' | 'decrease_selection';
export type InputStepperProps = {
    /** Label to show beneath the numeric value */
    label: string;
    /** Value to assign the numeric field */
    value: number;
    /** Maximum value allowed */
    max?: number;
    /** Minimum value allowed */
    min?: number;
    /** Action to perform when the value of this field has changed */
    onChange: (val: number) => void;
    /**
     * Label to use for accessibility purposes; will be read on the label, the
     * input field itself, and the stepper buttons via aria-labelledby
     */
    ariaLabel: string;
    /** Tracking callback to run when the step buttons are clicked */
    onStepperButtonClick?: (target: InputStepperButtonTargets) => void;
    /** Any additional styling that should be applied to the stepper */
    className?: string;
};
/**
 * Renders a numeric step input with an embedded label and a custom set of step buttons
 */
export declare const InputStepper: React.FC<InputStepperProps>;
