function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0) { ; } } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { isArray } from 'lodash';
import { forwardRef, useEffect, useRef, useState } from 'react';
import * as React from 'react';
import { Box } from '../Box';
import { ListEl } from './elements';
import { ListProvider, useList } from './ListProvider';
import { jsx as _jsx } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export var List = /*#__PURE__*/forwardRef(function List(_ref, ref) {
  var loading = _ref.loading,
    id = _ref.id,
    _ref$variant = _ref.variant,
    variant = _ref$variant === void 0 ? 'default' : _ref$variant,
    _ref$spacing = _ref.spacing,
    spacing = _ref$spacing === void 0 ? 'normal' : _ref$spacing,
    _ref$rowBreakpoint = _ref.rowBreakpoint,
    rowBreakpoint = _ref$rowBreakpoint === void 0 ? 'xs' : _ref$rowBreakpoint,
    _ref$scrollable = _ref.scrollable,
    scrollable = _ref$scrollable === void 0 ? false : _ref$scrollable,
    _ref$shadow = _ref.shadow,
    shadow = _ref$shadow === void 0 ? false : _ref$shadow,
    height = _ref.height,
    minHeight = _ref.minHeight,
    children = _ref.children,
    header = _ref.header,
    emptyMessage = _ref.emptyMessage,
    _ref$overflowHidden = _ref.overflowHidden,
    overflowHidden = _ref$overflowHidden === void 0 ? false : _ref$overflowHidden,
    _ref$scrollToTopOnUpd = _ref.scrollToTopOnUpdate,
    scrollToTopOnUpdate = _ref$scrollToTopOnUpd === void 0 ? false : _ref$scrollToTopOnUpd;
  var isEmpty = !children || isArray(children) && children.length === 0;
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isEnd = _useState2[0],
    setIsEnd = _useState2[1];
  var showShadow = shadow && scrollable && !isEnd;
  var value = useList({
    variant: variant,
    spacing: spacing,
    scrollable: scrollable,
    rowBreakpoint: rowBreakpoint
  });
  var topOfTable = useRef(null);
  useEffect(function () {
    if (scrollToTopOnUpdate && topOfTable.current !== null) {
      topOfTable.current.scrollTo({
        top: 0
      });
    }
  });
  var listContent = /*#__PURE__*/_jsx(ListEl, {
    ref: ref,
    variant: value.variant,
    children: children
  });
  var scrollHandler = function scrollHandler(event) {
    var _event$currentTarget = event.currentTarget,
      offsetWidth = _event$currentTarget.offsetWidth,
      scrollLeft = _event$currentTarget.scrollLeft,
      scrollWidth = _event$currentTarget.scrollWidth;
    setIsEnd(offsetWidth + scrollLeft >= scrollWidth);
  };
  var listContents = /*#__PURE__*/_jsxs(_Fragment, {
    children: [header, " ", isEmpty ? emptyMessage : listContent]
  });
  var content = isEmpty || loading ? /*#__PURE__*/_jsx(Box, {
    minWidth: "min-content",
    width: "100%",
    position: "relative",
    ref: topOfTable,
    children: listContents
  }) : listContents;
  return /*#__PURE__*/_jsx(ListProvider, {
    value: value,
    children: /*#__PURE__*/_jsxs(Box, {
      position: "relative",
      overflow: "hidden",
      width: 1,
      id: id,
      children: [/*#__PURE__*/_jsx(Box, {
        "data-testid": "scrollable-".concat(id),
        maxHeight: height,
        maxWidth: 1,
        minHeight: minHeight,
        onScroll: scrollable ? scrollHandler : undefined,
        overflow: overflowHidden ? 'hidden' : 'auto',
        position: "relative",
        ref: !isEmpty ? topOfTable : undefined,
        children: content
      }), showShadow && /*#__PURE__*/_jsx(Box, {
        position: "absolute",
        right: -10,
        top: 0,
        bottom: 0,
        width: 10,
        boxShadow: "0 0 48px black, 0 0 24px black"
      })]
    })
  });
});