import { createContext, useContext, useMemo } from 'react';
export var ListContext = /*#__PURE__*/createContext({});
ListContext.displayName = 'ListContext';
export var ListProvider = ListContext.Provider;
export function useListContext() {
  var context = useContext(ListContext);
  return context;
}
export function useList(_ref) {
  var spacing = _ref.spacing,
    variant = _ref.variant,
    scrollable = _ref.scrollable,
    rowBreakpoint = _ref.rowBreakpoint;
  var _useListContext = useListContext(),
    _useListContext$depth = _useListContext.depth,
    depth = _useListContext$depth === void 0 ? 0 : _useListContext$depth,
    parentVariant = _useListContext.variant,
    parentSpacing = _useListContext.spacing;
  var activeVariant = variant !== null && variant !== void 0 ? variant : parentVariant;
  var activeSpacing = spacing !== null && spacing !== void 0 ? spacing : parentSpacing;
  return useMemo(function () {
    return {
      root: depth === 0,
      scrollable: scrollable,
      variant: activeVariant,
      spacing: activeSpacing,
      rowBreakpoint: rowBreakpoint,
      depth: depth + 1
    };
  }, [scrollable, activeVariant, activeSpacing, depth, rowBreakpoint]);
}