function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { AnimatePresence, motion } from 'framer-motion';
import { forwardRef } from 'react';
import * as React from 'react';
import { Box } from '..';
import { RowEl } from './elements';
import { useListContext } from './ListProvider';
import { jsx as _jsx } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var ExpandInCollapseOut = function ExpandInCollapseOut(_ref) {
  var children = _ref.children;
  return /*#__PURE__*/_jsx(motion.div, {
    initial: "collapsed",
    exit: "collapsed",
    animate: "expanded",
    style: {
      overflow: 'hidden'
    },
    variants: {
      expanded: {
        height: 'auto'
      },
      collapsed: {
        height: 0
      }
    },
    transition: {
      duration: 0.2,
      ease: 'easeInOut'
    },
    children: children
  });
};
export var ListRow = /*#__PURE__*/forwardRef(function ListRow(_ref2, ref) {
  var children = _ref2.children,
    expanded = _ref2.expanded,
    expandedRowAriaLabel = _ref2.expandedRowAriaLabel,
    renderExpanded = _ref2.renderExpanded,
    keepSpacingWhileExpanded = _ref2.keepSpacingWhileExpanded,
    rest = _objectWithoutProperties(_ref2, ["children", "expanded", "expandedRowAriaLabel", "renderExpanded", "keepSpacingWhileExpanded"]);
  var _useListContext = useListContext(),
    variant = _useListContext.variant,
    scrollable = _useListContext.scrollable,
    rowBreakpoint = _useListContext.rowBreakpoint,
    rowConfig = _objectWithoutProperties(_useListContext, ["variant", "scrollable", "rowBreakpoint"]);
  var wrapperProps = !renderExpanded ? rowConfig : {
    spacing: keepSpacingWhileExpanded ? rowConfig.spacing : undefined
  };
  var content = children;
  if (renderExpanded) {
    content = /*#__PURE__*/_jsx(RowEl, _objectSpread(_objectSpread(_objectSpread({
      as: "div"
    }, rowConfig), {}, {
      "aria-expanded": rest !== null && rest !== void 0 && rest.onClick ? expanded : undefined,
      clickable: !!(rest !== null && rest !== void 0 && rest.onClick),
      role: rest !== null && rest !== void 0 && rest.onClick ? 'button' : rest === null || rest === void 0 ? void 0 : rest.role,
      tabIndex: rest !== null && rest !== void 0 && rest.onClick ? 0 : rest === null || rest === void 0 ? void 0 : rest.tabIndex,
      onClick: rest === null || rest === void 0 ? void 0 : rest.onClick
    }, rest), {}, {
      ref: ref,
      children: children
    }));
  }
  return /*#__PURE__*/_jsx(RowEl, _objectSpread(_objectSpread({
    variant: variant,
    expanded: !!renderExpanded,
    scrollable: scrollable,
    rowBreakpoint: rowBreakpoint
  }, wrapperProps), {}, {
    children: /*#__PURE__*/_jsxs(_Fragment, {
      children: [content, /*#__PURE__*/_jsx(AnimatePresence, {
        children: expanded && /*#__PURE__*/_jsx(ExpandInCollapseOut, {
          children: /*#__PURE__*/_jsx(Box, {
            role: "region",
            "aria-label": expandedRowAriaLabel,
            children: renderExpanded === null || renderExpanded === void 0 ? void 0 : renderExpanded()
          })
        })
      })]
    })
  }));
});