import { PureComponent } from 'react';
import * as React from 'react';
import { MarkdownOverrideSettings } from './libs/overrides';
export type SkipDefaultOverridesSettings = {
    a?: boolean;
    checkbox?: boolean;
    details?: boolean;
    iframe?: boolean;
    table?: boolean;
};
export type MarkdownProps = {
    className?: string;
    inline?: boolean;
    overrides?: MarkdownOverrideSettings;
    skipDefaultOverrides?: SkipDefaultOverridesSettings;
    /**
     * Enables generated header ids for H1-6 tags
     * Can generate duplicate IDs if used on separate markdown components on the same page
     */
    headerIds?: boolean;
    spacing?: 'loose' | 'tight' | 'none';
    text?: string;
    /**
     * Callback when a markdown anchor tag is clicked
     */
    onAnchorClick?: (event: React.MouseEvent<HTMLAnchorElement>) => void;
};
export declare class Markdown extends PureComponent<MarkdownProps> {
    render(): JSX.Element | null;
}
export type { MarkdownOverrideSetting, MarkdownOverrideSettings, } from './libs/overrides';
