import { HTMLAttributes } from 'react';
import * as React from 'react';
import { HTMLToReactNode } from '..';
interface MarkdownHTMLDetailsAttributes extends Omit<HTMLAttributes<HTMLDetailsElement>, 'children'> {
}
export interface MarkdownDetailsProps extends MarkdownHTMLDetailsAttributes {
    open?: boolean;
    children?: HTMLToReactNode[];
}
/**
 * Details element
 * By default, the <summary> element is not required, but the default "details" text is not easily styled
 * This ensures we always have a summary element to style and that the details are indented
 */
export declare const Details: React.FC<MarkdownDetailsProps>;
export {};
