function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { useMemo } from 'react';
import * as React from 'react';
import { Box } from '../../../../Box';
import { jsx as _jsx } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var getStyledDetailChildren = function getStyledDetailChildren(_ref) {
  var summaryIndex = _ref.summaryIndex,
    hasSummary = _ref.hasSummary,
    children = _ref.children;
  if (children && summaryIndex) {
    var copiedChildren = hasSummary ? children.slice(0, summaryIndex).concat(children.slice(summaryIndex + 1)) : children;
    var summary = hasSummary ? children[summaryIndex] : /*#__PURE__*/_jsx("summary", {
      children: "Details"
    });
    return {
      summary: summary,
      children: /*#__PURE__*/_jsx(Box, {
        ml: 24,
        children: /*#__PURE__*/_jsx(_Fragment, {
          children: copiedChildren.map(function (elem) {
            return elem;
          })
        })
      })
    };
  }
};

/**
 * Details element
 * By default, the <summary> element is not required, but the default "details" text is not easily styled
 * This ensures we always have a summary element to style and that the details are indented
 */
export var Details = function Details(_ref2) {
  var children = _ref2.children,
    props = _objectWithoutProperties(_ref2, ["children"]);
  var editedDetails = useMemo(function () {
    var summaryIndex = children === null || children === void 0 ? void 0 : children.findIndex(function (e) {
      return e.type === 'summary';
    });
    var hasSummary = Boolean(summaryIndex && summaryIndex > 0 && children);
    return getStyledDetailChildren({
      summaryIndex: summaryIndex,
      hasSummary: hasSummary,
      children: children
    });
  }, [children]);
  return /*#__PURE__*/_jsx("details", _objectSpread(_objectSpread({
    "data-testid": "gamut-md-details"
  }, props), {}, {
    children: /*#__PURE__*/_jsxs(_Fragment, {
      children: [editedDetails === null || editedDetails === void 0 ? void 0 : editedDetails.summary, editedDetails === null || editedDetails === void 0 ? void 0 : editedDetails.children]
    })
  }));
};