function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0) { ; } } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import cx from 'classnames';
import HtmlToReact from 'html-to-react';
import camelCaseMap from 'html-to-react/lib/camel-case-attribute-names';
import { get } from 'lodash';
import * as React from 'react';

// eslint-disable-next-line gamut/no-css-standalone
import styles from '../../styles/index.module.scss';
import { getLabel, isCheckboxParent, isInput, isLabelText } from './utils';
import { jsx as _jsx } from "react/jsx-runtime";
var processNodeDefinitions = HtmlToReact.ProcessNodeDefinitions();
// Mapping of html attributes to their camelCase variants
var attributeMap = _objectSpread(_objectSpread({}, camelCaseMap), {}, {
  "for": 'htmlFor',
  "class": 'className'
});
var processAttributeValue = function processAttributeValue(value) {
  if (value === 'true') {
    return true;
  }
  if (value === 'false') {
    return false;
  }
  return value || true;
};

// Convert html attributes to valid react props
export var processAttributes = function processAttributes() {
  var attributes = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return Object.keys(attributes).reduce(function (acc, attr) {
    var reactAttr = attributeMap[attr.replace(/[-:]/, '')] || attr;
    return _objectSpread(_objectSpread({}, acc), {}, _defineProperty({}, reactAttr, processAttributeValue(attributes[attr])));
  }, {});
};

// generic html tag override
export var createTagOverride = function createTagOverride(tagName, Override) {
  return {
    shouldProcessNode: function shouldProcessNode(node) {
      if (!Override) return false;
      if (Override.shouldProcessNode) {
        return Override.shouldProcessNode(node);
      }
      return node.name === tagName.toLowerCase();
    },
    processNode: function processNode(node, children, key) {
      if (!Override) return null;
      var props = _objectSpread(_objectSpread({}, processAttributes(node.attribs)), {}, {
        children: children,
        key: key
      });
      if (Override.processNode) {
        return Override.processNode(node, props);
      }
      if (!Override.component) return null;
      return /*#__PURE__*/_jsx(Override.component, _objectSpread({}, props));
    }
  };
};

// Allows <CodeBlock></CodeBlock> override and overrides of standard fenced codeblocks
export var createCodeBlockOverride = function createCodeBlockOverride(tagName, Override) {
  return createTagOverride(tagName, _objectSpread({
    shouldProcessNode: function shouldProcessNode(node) {
      return node.name === 'code' && get(node, 'parent.name') === 'pre' || node.name === tagName.toLowerCase();
    },
    processNode: function processNode(node, props) {
      var _props$className, _props$children;
      var _ref = ((_props$className = props.className) === null || _props$className === void 0 ? void 0 : _props$className.match(/language-([^\s]+)/)) || [],
        _ref2 = _slicedToArray(_ref, 2),
        _ref2$ = _ref2[1],
        language = _ref2$ === void 0 ? undefined : _ref2$;
      if (!Override.component) return null;
      return /*#__PURE__*/_jsx(Override.component, _objectSpread(_objectSpread({}, props), {}, {
        language: language,
        children: (_props$children = props.children) === null || _props$children === void 0 ? void 0 : _props$children[0]
      }));
    }
  }, Override));
};
export var createInputOverride = function createInputOverride(type, Override) {
  return createTagOverride('input', _objectSpread({
    shouldProcessNode: function shouldProcessNode(node) {
      return isCheckboxParent(node, type) || isInput(node, type) || isLabelText(node, type);
    },
    processNode: function processNode(node, props) {
      var label = getLabel(node);
      if (!Override.component) return null;
      if (isCheckboxParent(node, type)) {
        var className = props.className,
          rest = _objectWithoutProperties(props, ["className"]);
        var plainLiClass = cx(styles["checkbox-parent"], className);
        return /*#__PURE__*/_jsx("li", _objectSpread({
          className: plainLiClass
        }, rest));
      }
      if (isLabelText(node, type)) return null;
      return /*#__PURE__*/_jsx(Override.component, _objectSpread({
        label: label
      }, props));
    }
  }, Override));
};
var processText = function processText(text) {
  // Replace &mdash; due to legacy markdown that didn't use smart dashes
  return text.replace(/&mdash;/g, "\u2014");
};
export var standardOverrides = [{
  shouldProcessNode: function shouldProcessNode(node) {
    // Parse text outside of code blocks
    if (node.parent && ['code', 'pre'].indexOf(node.parent.name) >= 0) {
      return false;
    }
    if (node.type === 'text') return true;
    return false;
  },
  processNode: function processNode(node) {
    return processText(node.data);
  }
}, {
  shouldProcessNode: function shouldProcessNode() {
    return true;
  },
  processNode: processNodeDefinitions.processDefaultNode
}];