/// <reference types="react" />
export interface MenuContextProps {
    spacing: 'normal' | 'condensed';
    variant: 'select' | 'navigation' | 'action';
    depth: number;
}
export declare const MenuContext: import("react").Context<MenuContextProps>;
export declare const MenuProvider: import("react").Provider<MenuContextProps>;
export declare function useMenu({ spacing, variant }: Omit<MenuContextProps, 'depth'>): {
    readonly root: boolean;
    readonly role: "menu" | "group";
    readonly variant: "select" | "navigation" | "action";
    readonly spacing: "normal" | "condensed";
    readonly depth: number;
};
export declare function useMenuContext(): MenuContextProps;
