function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { createContext, useContext } from 'react';
export var MenuContext = /*#__PURE__*/createContext({
  spacing: 'normal',
  variant: 'select',
  depth: 0
});
MenuContext.displayName = 'MenuContext';
export var MenuProvider = MenuContext.Provider;
export function useMenu(_ref) {
  var spacing = _ref.spacing,
    variant = _ref.variant;
  var _useContext = useContext(MenuContext),
    depth = _useContext.depth,
    contextProps = _objectWithoutProperties(_useContext, ["depth"]);
  var root = depth === 0;
  var nextDepth = depth + 1;
  return {
    root: root,
    role: root ? 'menu' : 'group',
    variant: root ? variant : contextProps.variant,
    spacing: root ? spacing : contextProps.spacing,
    depth: nextDepth
  };
}
export function useMenuContext() {
  var context = useContext(MenuContext);
  return context;
}