function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { forwardRef } from 'react';
import { Text } from '../Typography';
import { ListButton, ListItem, ListLink } from './elements';
import { useMenuContext } from './MenuContext';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";
var getListItemType = function getListItemType(href, onClick) {
  return href ? 'link' : onClick ? 'button' : 'item';
};
var activePropnames = {
  navigation: 'active-navlink',
  action: 'active',
  select: 'selected'
};
var currentItemText = {
  link: 'current page',
  button: 'current action',
  item: 'current item'
};
export var MenuItem = /*#__PURE__*/forwardRef(function MenuItem(_ref, ref) {
  var href = _ref.href,
    target = _ref.target,
    children = _ref.children,
    active = _ref.active,
    Icon = _ref.icon,
    props = _objectWithoutProperties(_ref, ["href", "target", "children", "active", "icon"]);
  var _useMenuContext = useMenuContext(),
    variant = _useMenuContext.variant,
    rest = _objectWithoutProperties(_useMenuContext, ["variant"]);
  var activeProp = activePropnames[variant];
  var computed = _objectSpread(_objectSpread(_objectSpread({}, props), rest), {}, _defineProperty({
    variant: variant === 'select' ? 'select' : 'link',
    role: 'menuitem'
  }, activeProp, active));
  var listItemType = getListItemType(!!href, !!props.onClick);
  var content = /*#__PURE__*/_jsxs(_Fragment, {
    children: [Icon && /*#__PURE__*/_jsx(Icon, {
      size: rest.spacing === 'condensed' ? 16 : 24,
      mr: 12,
      "data-testid": "menuitem-icon"
    }), active && /*#__PURE__*/_jsxs(Text, {
      screenreader: true,
      children: [currentItemText[listItemType], ","]
    }), children]
  });
  if (listItemType === 'link') {
    var linkRef = ref;
    return /*#__PURE__*/_jsx(ListItem, {
      role: "none",
      children: /*#__PURE__*/_jsx(ListLink, _objectSpread(_objectSpread({}, computed), {}, {
        href: href,
        ref: linkRef,
        target: target,
        children: content
      }))
    });
  }
  if (listItemType === 'button') {
    var buttonRef = ref;
    return /*#__PURE__*/_jsx(ListItem, {
      role: "none",
      children: /*#__PURE__*/_jsx(ListButton, _objectSpread(_objectSpread({}, computed), {}, {
        ref: buttonRef,
        children: content
      }))
    });
  }
  var liRef = ref;
  return /*#__PURE__*/_jsx(ListItem, _objectSpread(_objectSpread({}, computed), {}, {
    ref: liRef,
    children: content
  }));
});