import * as React from 'react';
import { OverlayProps } from '../Overlay';
export type ModalDeprecatedOverlayProps = Partial<Pick<OverlayProps, 'clickOutsideCloses' | 'escapeCloses' | 'className'>>;
export type ModalDeprecatedProps = {
    children?: React.ReactNode;
    className?: string;
    /**
     * Whether the ModalDeprecated is open or closed
     */
    isOpen: boolean;
    /**
     * A function that is called when the ModalDeprecated expects to be closed
     * Triggered automatically by the Overlay component in certain situations
     */
    onRequestClose: () => void;
    /**
     * See Overlay component for prop definitions
     * @description ModalDeprecatedOverlayProps
     */
    overlayProps?: ModalDeprecatedOverlayProps;
    /**
     * Whether to hide the default close button and pass your own through children
     */
    hideDefaultCloseButton?: boolean;
    ariaLabel?: string;
};
/**
 * @deprecated  This component is deprecated and will be updated soon.
 *
 * Please check the gamut board for updates on the new version of ModalDeprecated
 */
export declare const ModalDeprecated: React.FC<ModalDeprecatedProps>;
