import { ComponentProps } from 'react';
import * as React from 'react';
import { FillButton } from '../Button';
import { ModalContainerProps } from './elements';
import { ModalBaseProps } from './types';
interface DialogButtonProps {
    children: React.ReactNode;
    href?: string;
    onClick?: ComponentProps<typeof FillButton>['onClick'];
}
export interface DialogProps extends ModalBaseProps {
    title: ModalBaseProps['title'];
    size?: Exclude<ModalContainerProps['size'], 'fluid' | false>;
    variant?: Extract<ComponentProps<typeof FillButton>['variant'], 'primary' | 'danger'>;
    confirmCta: DialogButtonProps;
    cancelCta?: DialogButtonProps;
}
export declare const Dialog: React.FC<DialogProps>;
export {};
