function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { MiniDeleteIcon } from '@codecademy/gamut-icons';
import * as React from 'react';
import { Box } from '../Box';
import { FillButton, IconButton, TextButton } from '../Button';
import { Overlay } from '../Overlay';
import { Text } from '../Typography';
import { ModalContainer } from './elements';
import { ImageContainer } from './ImageContainer';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export var Dialog = function Dialog(_ref) {
  var title = _ref.title,
    variant = _ref.variant,
    children = _ref.children,
    confirmCta = _ref.confirmCta,
    cancelCta = _ref.cancelCta,
    onRequestClose = _ref.onRequestClose,
    image = _ref.image,
    _ref$size = _ref.size,
    size = _ref$size === void 0 ? 'small' : _ref$size,
    rest = _objectWithoutProperties(_ref, ["title", "variant", "children", "confirmCta", "cancelCta", "onRequestClose", "image", "size"]);
  var onConfirm = function onConfirm(e) {
    var _confirmCta$onClick;
    onRequestClose();
    (_confirmCta$onClick = confirmCta.onClick) === null || _confirmCta$onClick === void 0 ? void 0 : _confirmCta$onClick.call(confirmCta, e);
  };
  var onCancel = function onCancel(e) {
    var _cancelCta$onClick;
    onRequestClose();
    cancelCta === null || cancelCta === void 0 ? void 0 : (_cancelCta$onClick = cancelCta.onClick) === null || _cancelCta$onClick === void 0 ? void 0 : _cancelCta$onClick.call(cancelCta, e);
  };
  return /*#__PURE__*/_jsx(Overlay, _objectSpread(_objectSpread({
    shroud: true,
    onRequestClose: onCancel
  }, rest), {}, {
    children: /*#__PURE__*/_jsxs(ModalContainer, {
      size: size,
      "aria-hidden": "false",
      "aria-modal": "true",
      role: "dialog",
      layout: "dialog",
      children: [/*#__PURE__*/_jsx(Text, {
        as: "h2",
        fontSize: 20,
        lineHeight: "base",
        gridArea: "title",
        children: title
      }), /*#__PURE__*/_jsx(IconButton, {
        "aria-label": "Close Dialog",
        size: "small",
        alignSelf: "start",
        icon: MiniDeleteIcon,
        onClick: onCancel,
        gridArea: "close"
      }), /*#__PURE__*/_jsxs(Box, {
        as: "div",
        gridArea: "content",
        "data-testid": "dialog-content",
        children: [image && /*#__PURE__*/_jsx(ImageContainer, {
          image: image,
          size: size
        }), children]
      }), cancelCta && /*#__PURE__*/_jsx(TextButton, _objectSpread(_objectSpread({}, cancelCta), {}, {
        variant: "secondary",
        onClick: onCancel,
        justifySelf: "end",
        gridArea: "cancel"
      })), /*#__PURE__*/_jsx(FillButton, _objectSpread(_objectSpread({}, confirmCta), {}, {
        variant: variant,
        onClick: onConfirm,
        gridArea: "confirm"
      }))]
    })
  }));
};