import { timingValues } from '@codecademy/gamut-styles';
import { motion } from 'framer-motion';
import * as React from 'react';
import { Box } from '../Box';
import { jsx as _jsx } from "react/jsx-runtime";
var exitDuration = timingValues.fast / 1000;
var motionVariants = {
  initial: {
    height: 0,
    opacity: 0
  },
  visible: {
    opacity: 1,
    height: 'auto',
    transition: {
      duration: exitDuration
    }
  },
  exit: {
    height: 0,
    opacity: 0,
    x: 100,
    transition: {
      duration: exitDuration,
      height: {
        delay: exitDuration
      }
    }
  }
};
var BaseContainer = motion(Box);
export var FadeInSlideOut = function FadeInSlideOut(_ref) {
  var children = _ref.children;
  return /*#__PURE__*/_jsx(BaseContainer, {
    variants: motionVariants,
    initial: "initial",
    animate: "visible",
    exit: "exit",
    py: 8,
    children: children
  });
};