import * as React from 'react';
export type OverlayProps = {
    children: React.ReactElement<any>;
    className?: string;
    /**
     * Whether clicking on the screen outside of the container should close the Overlay.
     */
    clickOutsideCloses?: boolean;
    /**
     * Whether clicking the escape key should close the Overlay.
     */
    escapeCloses?: boolean;
    /**
     * Called when the Overlay requests to be closed,
     * this could be due to clicking outside of the overlay, or by clicking the escape key.
     */
    onRequestClose: () => void;
    /**
     * Whether the overlay is rendered.
     */
    isOpen?: boolean;
    /** Whether the overlay renders inline to its container or creates a portal to the end of the body */
    inline?: boolean;
    /** Whether the overlay has a transparent or a shrouded background with slight opacity */
    shroud?: boolean;
    /** Whether the overlay allows scroll */
    allowScroll?: boolean;
};
export declare const Overlay: React.FC<OverlayProps>;
