function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { forwardRef, useMemo } from 'react';
import * as React from 'react';
import { createButtonComponent } from '../Button/shared';
import { paginationStrokeButtonStates, paginationStrokeVariant, paginationTextButtonStates, paginationTextVariant } from './styles';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var PaginationTextButtonInner = createButtonComponent(paginationTextButtonStates, paginationTextVariant);
var PaginationStrokeButtonInner = createButtonComponent(paginationStrokeButtonStates, paginationStrokeVariant);
export var PaginationButton = /*#__PURE__*/forwardRef(function PaginationButton(_ref, ref) {
  var children = _ref.children,
    Icon = _ref.icon,
    _ref$variant = _ref.variant,
    variant = _ref$variant === void 0 ? 'stroke' : _ref$variant,
    _ref$showButton = _ref.showButton,
    showButton = _ref$showButton === void 0 ? 'shown' : _ref$showButton,
    props = _objectWithoutProperties(_ref, ["children", "icon", "variant", "showButton"]);
  var ButtonStyleWrapper = useMemo(function () {
    return variant === 'stroke' ? PaginationStrokeButtonInner : PaginationTextButtonInner;
  }, [variant]);
  return /*#__PURE__*/_jsxs(ButtonStyleWrapper, _objectSpread(_objectSpread({
    "aria-hidden": showButton === 'hidden',
    showButton: showButton
  }, props), {}, {
    ref: ref,
    children: [Icon && /*#__PURE__*/_jsx(Icon, {
      width: 14,
      height: 14,
      "aria-hidden": true
    }), children]
  }));
});