import * as React from 'react';
export interface PaginationProps {
    /**
     * Number of page buttons to show at once
     */
    chapterSize?: number;
    /**
     * Default initial page number, if none will default to one
     */
    defaultPageNumber?: number;
    /**
     * Whether pagination should act as standard link-based navigation.
     */
    isNavigation?: boolean;
    /**
     * Called when the page number is changed with the resulting page number as its first argument
     */
    onChange: (arg0: number) => void;
    /**
     * Controlled page number
     */
    pageNumber?: number;
    /**
     * Total number of pages
     */
    totalPages: number;
    /**
     *  Basic pagination vs ellipsis types, will default to basic if under 10 pages unless specified.
     */
    type?: 'basic' | 'includeSkipToButtons';
    /**
     *  Stroke or text button style
     */
    variant?: 'stroke' | 'text';
}
export declare const Pagination: React.FC<PaginationProps>;
