function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0) { ; } } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { MiniChevronLeftIcon, MiniChevronRightIcon } from '@codecademy/gamut-icons';
import { useMemo, useState } from 'react';
import * as React from 'react';
import { HiddenText } from '..';
import { FlexBox } from '../Box';
import { AnimatedFadeButton, AnimatedSlideButton } from './AnimatedPaginationButtons';
import { EllipsisButton } from './EllipsisButton';
import { PaginationButton } from './PaginationButton';
import { hideOnMobile } from './styles';
import { getBackPageNumber, getForwardPageNumber, getMinWidth, shouldPagesChange } from './utils';
import { jsx as _jsx } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export var Pagination = function Pagination(_ref) {
  var _ref$chapterSize = _ref.chapterSize,
    chapterSize = _ref$chapterSize === void 0 ? 5 : _ref$chapterSize,
    _ref$defaultPageNumbe = _ref.defaultPageNumber,
    defaultPageNumber = _ref$defaultPageNumbe === void 0 ? 1 : _ref$defaultPageNumbe,
    navigation = _ref.isNavigation,
    onChange = _ref.onChange,
    pageNumber = _ref.pageNumber,
    totalPages = _ref.totalPages,
    type = _ref.type,
    _ref$variant = _ref.variant,
    variant = _ref$variant === void 0 ? 'stroke' : _ref$variant;
  var _useState = useState(pageNumber !== null && pageNumber !== void 0 ? pageNumber : defaultPageNumber),
    _useState2 = _slicedToArray(_useState, 2),
    currentPage = _useState2[0],
    setCurrentPage = _useState2[1];
  var _useState3 = useState(''),
    _useState4 = _slicedToArray(_useState3, 2),
    liveText = _useState4[0],
    setLiveText = _useState4[1];
  var _useState5 = useState([0]),
    _useState6 = _slicedToArray(_useState5, 2),
    shownPageArray = _useState6[0],
    setShownPageArray = _useState6[1];
  var showSkipToButtons = !!(type === undefined && totalPages >= 10 || type === 'includeSkipToButtons');
  var changeShownPages = shouldPagesChange({
    chapterSize: chapterSize,
    currentPage: currentPage,
    shownPageArray: shownPageArray,
    totalPages: totalPages
  });
  var backPageNumber = getBackPageNumber({
    chapterSize: chapterSize,
    shownPageArray: shownPageArray
  });
  var forwardPageNumber = getForwardPageNumber({
    chapterSize: chapterSize,
    shownPageArray: shownPageArray,
    totalPages: totalPages
  });
  useMemo(function () {
    var currentChapterSize = chapterSize > totalPages ? totalPages : chapterSize;
    var firstPageChapter = totalPages - currentPage < currentChapterSize ? totalPages - (currentChapterSize - 1) : currentPage;
    setShownPageArray(Array.from(Array(currentChapterSize), function (_, index) {
      return index + firstPageChapter;
    }));
    setLiveText("Viewing navigation for pages ".concat(shownPageArray[0], " through\n          ").concat(shownPageArray[shownPageArray.length - 1], ", current page ").concat(currentPage));
  },
  // eslint-disable-next-line react-hooks/exhaustive-deps
  [changeShownPages, totalPages]);
  var changeHandler = function changeHandler(pageChange) {
    setCurrentPage(pageChange);
    onChange(pageChange);
    setLiveText("Current page ".concat(pageChange));
  };
  useMemo(function () {
    if (pageNumber) changeHandler(pageNumber);
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [pageNumber]);
  return /*#__PURE__*/_jsxs(FlexBox, {
    as: navigation ? 'nav' : undefined,
    "aria-label": navigation ? "Browse Content By Page, total pages ".concat(totalPages) : "Paginated Navigation, total pages ".concat(totalPages),
    justifyContent: "center",
    minWidth: {
      _: 'initial',
      sm: "".concat(showSkipToButtons ? getMinWidth({
        chapterSize: chapterSize
      }) : 'initial')
    },
    children: [/*#__PURE__*/_jsx(HiddenText, {
      "aria-live": "polite",
      children: liveText
    }), /*#__PURE__*/_jsx(AnimatedFadeButton, {
      "aria-label": "Navigate back to page ".concat(currentPage - 1),
      direction: "back",
      href: navigation,
      icon: MiniChevronLeftIcon,
      onClick: function onClick() {
        return changeHandler(currentPage - 1);
      },
      showButton: currentPage === 1 ? 'hidden' : 'shown',
      variant: variant
    }), showSkipToButtons && /*#__PURE__*/_jsxs(_Fragment, {
      children: [/*#__PURE__*/_jsx(AnimatedSlideButton, {
        "aria-label": "Jump back to page 1",
        direction: "back",
        display: hideOnMobile,
        href: navigation,
        onClick: function onClick() {
          return changeHandler(1);
        },
        showButton: shownPageArray[0] === 1 ? 'hidden' : 'shown',
        variant: variant,
        children: "1"
      }), /*#__PURE__*/_jsx(EllipsisButton, {
        "aria-label": "Jump back to page ".concat(backPageNumber),
        direction: "back",
        display: hideOnMobile,
        href: navigation,
        onClick: function onClick() {
          return changeHandler(backPageNumber);
        },
        variant: variant,
        showButton: shownPageArray[0] === 1 ? 'hidden' : 'shown'
      })]
    }), shownPageArray.map(function (page) {
      return /*#__PURE__*/_jsx(PaginationButton, {
        "aria-current": page === currentPage && 'page',
        "aria-label": "".concat(page === totalPages ? 'Last Page, ' : '', "Page ").concat(page),
        href: navigation,
        onClick: function onClick() {
          return changeHandler(page);
        },
        selected: page === currentPage,
        variant: variant,
        children: page
      }, page);
    }), showSkipToButtons && /*#__PURE__*/_jsxs(_Fragment, {
      children: [/*#__PURE__*/_jsx(EllipsisButton, {
        "aria-label": "Jump forward to page ".concat(forwardPageNumber),
        display: hideOnMobile,
        direction: "forward",
        onClick: function onClick() {
          changeHandler(forwardPageNumber);
        },
        href: navigation,
        showButton: shownPageArray[chapterSize - 1] === totalPages ? 'hidden' : 'shown',
        variant: variant
      }), /*#__PURE__*/_jsx(AnimatedSlideButton, {
        "aria-label": "Jump forward to last page, page ".concat(totalPages),
        direction: "forward",
        display: hideOnMobile,
        href: navigation,
        onClick: function onClick() {
          return changeHandler(totalPages);
        },
        showButton: shownPageArray[chapterSize - 1] === totalPages ? 'hidden' : 'shown',
        variant: variant,
        children: totalPages
      })]
    }), /*#__PURE__*/_jsx(AnimatedFadeButton, {
      "aria-label": "Navigate forward to page ".concat(currentPage + 1),
      as: navigation ? 'a' : undefined,
      direction: "forward",
      href: navigation,
      icon: MiniChevronRightIcon,
      onClick: function onClick() {
        return changeHandler(currentPage + 1);
      },
      showButton: currentPage === totalPages ? 'hidden' : 'shown',
      variant: variant
    })]
  });
};