import * as React from 'react';
import { BaseEllipsisButton } from './EllipsisButton';
import { PaginationButton } from './PaginationButton';
type PaginationUtils = {
    chapterSize: number;
    currentPage: number;
    shownPageArray: number[];
    totalPages: number;
};
export declare const shouldPagesChange: ({ chapterSize, currentPage, shownPageArray, totalPages, }: PaginationUtils) => boolean;
export declare const getBackPageNumber: ({ shownPageArray, chapterSize, }: Omit<PaginationUtils, 'totalPages' | 'currentPage'>) => number;
export declare const getForwardPageNumber: ({ chapterSize, totalPages, shownPageArray, }: Omit<PaginationUtils, 'currentPage'>) => number;
export declare const getMinWidth: ({ chapterSize, }: Pick<PaginationUtils, 'chapterSize'>) => string;
type WrappedComponentProps<WrappedComponentProps extends typeof BaseEllipsisButton> = React.ComponentProps<WrappedComponentProps>;
export declare const wrapWithSlideAnimation: (WrappedComponent: typeof BaseEllipsisButton) => (props: Pick<import("./EllipsisButton").EllipsisButtonProps, keyof import("./EllipsisButton").EllipsisButtonProps> & React.RefAttributes<import("..").ButtonBaseElements>) => JSX.Element;
export declare const createAnimatedFadeButton: (WrappedComponent: typeof PaginationButton) => (props: Pick<import("./PaginationButton").PaginationButtonProps, keyof import("./PaginationButton").PaginationButtonProps> & React.RefAttributes<import("..").ButtonBaseElements>) => JSX.Element;
export {};
