function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import { AnimatePresence, motion } from 'framer-motion';
import { useEffect, useRef } from 'react';
import * as React from 'react';
import { jsx as _jsx } from "react/jsx-runtime";
export var shouldPagesChange = function shouldPagesChange(_ref) {
  var chapterSize = _ref.chapterSize,
    currentPage = _ref.currentPage,
    shownPageArray = _ref.shownPageArray,
    totalPages = _ref.totalPages;
  return currentPage < shownPageArray[0] || (currentPage || totalPages) > shownPageArray[chapterSize - 1] || shownPageArray[0] === 0;
};
export var getBackPageNumber = function getBackPageNumber(_ref2) {
  var shownPageArray = _ref2.shownPageArray,
    chapterSize = _ref2.chapterSize;
  return shownPageArray[0] - chapterSize < 1 ? 1 : shownPageArray[0] - chapterSize;
};
export var getForwardPageNumber = function getForwardPageNumber(_ref3) {
  var chapterSize = _ref3.chapterSize,
    totalPages = _ref3.totalPages,
    shownPageArray = _ref3.shownPageArray;
  return shownPageArray[0] + chapterSize >= totalPages ? totalPages : shownPageArray[0] + chapterSize;
};
export var getMinWidth = function getMinWidth(_ref4) {
  var chapterSize = _ref4.chapterSize;
  return "".concat(chapterSize * 3 + 18, "rem");
};
var slideAnimationVariants = {
  shown: {
    width: 'initial',
    overflow: 'hidden',
    transitionEnd: {
      overflow: 'visible'
    }
  },
  hidden: {
    width: 0,
    overflow: 'hidden',
    transitionEnd: {
      overflow: 'visible'
    }
  }
};
export var wrapWithSlideAnimation = function wrapWithSlideAnimation(WrappedComponent) {
  return function (props) {
    var isFirstRender = useRef(true);
    useEffect(function () {
      // stops the initial mount of the forward buttons from animating in
      isFirstRender.current = false;
    }, []);
    return /*#__PURE__*/_jsx(AnimatePresence, {
      children: props.showButton === 'shown' && /*#__PURE__*/_jsx(motion.div, {
        animate: props.showButton,
        initial: props.direction === 'forward' && isFirstRender.current ? 'shown' : 'hidden',
        variants: slideAnimationVariants,
        exit: "hidden",
        transition: {
          duration: 0.3
        },
        children: /*#__PURE__*/_jsx(WrappedComponent, _objectSpread({}, props))
      })
    });
  };
};
var fadeAnimationVariants = {
  shown: {
    opacity: 1,
    cursor: 'pointer'
  },
  hidden: {
    opacity: 0,
    cursor: 'default'
  }
};
export var createAnimatedFadeButton = function createAnimatedFadeButton(WrappedComponent) {
  var AnimatedButton = motion(WrappedComponent);
  return function (props) {
    return /*#__PURE__*/_jsx(AnimatedButton, _objectSpread(_objectSpread({}, props), {}, {
      "aria-label": props.showButton === 'hidden' ? null : props['aria-label'],
      animate: props.showButton,
      initial: false,
      variants: fadeAnimationVariants,
      disabled: props.showButton === 'hidden',
      transitionStart: {
        visibility: 'visible'
      },
      transition: {
        duration: 0.3,
        ease: [0.04, 0.62, 0.23, 0.98]
      },
      transitionEnd: {
        visibility: 'hidden'
      }
    }));
  };
};