function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import { states, variant } from '@codecademy/gamut-styles';
import { tooltipArrowHeight, tooltipBackgroundColor, toolTipBodyCss } from '../ToolTip/styles';
import { createVariantsFromAlignments } from '../ToolTip/utils';
import { createBeakVariantFromAlignment, createPatternVariantFromAlignment } from './utils';
export var popoverStates = states({
  widthRestricted: {
    minWidth: '4rem',
    maxWidth: '16rem'
  }
});
export var raisedDivVariants = variant({
  base: {
    zIndex: 1
  },
  defaultVariant: 'primary',
  variants: {
    primary: {
      bg: 'background',
      borderRadius: '2px'
    },
    secondary: _objectSpread({}, toolTipBodyCss)
  }
});
export var outlineVariants = variant({
  defaultVariant: 'boxShadow',
  prop: 'outline',
  variants: {
    boxShadow: {
      boxShadow: '0 0 16px rgba(0, 0, 0, 0.1), 0 0 24px rgba(0, 0, 0, 0.15)'
    },
    outline: {
      borderColor: 'secondary',
      border: 1,
      boxShadow: 'none'
    }
  }
});
var beakVariantsArray = ['below-left', 'below-right', 'below-center', 'above-left', 'above-right', 'above-center', 'below-left-sml', 'below-right-sml', 'below-center-sml', 'above-left-sml', 'above-right-sml', 'above-center-sml'];
var beakVariantStyles = createVariantsFromAlignments(beakVariantsArray, createBeakVariantFromAlignment);
export var beakVariants = variant({
  base: {
    bg: tooltipBackgroundColor,
    position: 'absolute',
    transform: 'rotate(45deg)'
  },
  prop: 'beak',
  variants: beakVariantStyles
});
export var beakSize = variant({
  prop: 'size',
  defaultVariant: 'lrg',
  variants: {
    sml: {
      bg: tooltipBackgroundColor,
      height: tooltipArrowHeight,
      width: tooltipArrowHeight
    },
    lrg: {
      bg: 'background',
      height: '20px',
      width: '20px'
    }
  }
});
var patternVariantArray = ['above-left', 'above-right', 'below-left', 'below-right'];
export var patternVariantStyles = createVariantsFromAlignments(patternVariantArray, createPatternVariantFromAlignment);
export var transformValues = {
  right: 'translateX(-100%)',
  left: 'translateX(0%)',
  above: 'translateY(-100%)',
  below: 'translateY(0%)'
};