function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0) { ; } } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { percentageOrAbsolute as percent } from '@codecademy/variance';
export var isInView = function isInView(_ref) {
  var top = _ref.top,
    left = _ref.left,
    bottom = _ref.bottom,
    right = _ref.right;
  var windowHeight = window.innerHeight || document.documentElement.clientHeight;
  var windowWidth = window.innerWidth || document.documentElement.clientWidth;
  return top >= 0 && left >= 0 && bottom <= windowHeight && right <= windowWidth;
};
export var ALIGN = {
  top: 'bottom',
  right: 'left',
  bottom: 'top',
  left: 'right'
};
var AXIS = {
  x: {
    top: 0,
    right: -1,
    bottom: 0,
    left: 1
  },
  y: {
    top: 1,
    right: 0,
    bottom: -1,
    left: 0
  },
  none: {
    top: 0,
    right: 0,
    bottom: 0,
    left: 0
  }
};
export var getPosition = function getPosition(_ref2) {
  var alignment = _ref2.alignment,
    container = _ref2.container,
    _ref2$offset = _ref2.offset,
    offset = _ref2$offset === void 0 ? 0 : _ref2$offset,
    _ref2$x = _ref2.x,
    x = _ref2$x === void 0 ? 0 : _ref2$x,
    _ref2$y = _ref2.y,
    y = _ref2$y === void 0 ? 0 : _ref2$y,
    invertAxis = _ref2.invertAxis;
  var top = container.top,
    left = container.left,
    bottom = container.bottom,
    right = container.right,
    height = container.height,
    width = container.width;
  var xOffset = width + offset + x;
  var yOffset = height + offset + y;
  var styles = {};
  var alignments = alignment.split('-');
  if (alignments.length === 1) {
    switch (alignments[0]) {
      case 'left':
      case 'right':
        styles.transform = 'translate(0, -50%)';
        styles.top = top + height / 2;
        break;
      case 'top':
      case 'bottom':
        styles.transform = 'translate(-50%, 0)';
        styles.left = left + width / 2;
    }
  } else {
    var coef = AXIS[invertAxis !== null && invertAxis !== void 0 ? invertAxis : 'none'];
    var _alignments = _slicedToArray(alignments, 2),
      _y = _alignments[0],
      _x = _alignments[1];
    styles.transform = "translate(".concat(percent(coef[_x]), ", ").concat(percent(coef[_y]), ")");
  }
  alignments.forEach(function (alignment) {
    if (alignment === 'left') styles.right = right + xOffset;
    if (alignment === 'right') styles.left = left + xOffset;
    if (alignment === 'top') styles.bottom = bottom + yOffset;
    if (alignment === 'bottom') styles.top = top + yOffset;
  });
  return styles;
};
export var getContainers = function getContainers(target) {
  var inline = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
  var scroll = arguments.length > 2 ? arguments[2] : undefined;
  var boundingClient = target.getBoundingClientRect();
  if (!inline) {
    var _width = boundingClient.width,
      _top = boundingClient.top,
      _height = boundingClient.height,
      _left = boundingClient.left;
    return {
      viewport: boundingClient,
      parent: {
        width: _width,
        height: _height,
        top: _top + scroll.y,
        left: _left,
        right: document.body.offsetWidth - _width - _left,
        bottom: -1 * (_top + _height + scroll.y)
      }
    };
  }
  var height = target.offsetHeight,
    width = target.offsetWidth,
    left = target.offsetLeft,
    top = target.offsetTop;
  var offsetParent = target === null || target === void 0 ? void 0 : target.offsetParent;
  return {
    parent: {
      width: width,
      height: height,
      left: left,
      right: (offsetParent === null || offsetParent === void 0 ? void 0 : offsetParent.offsetWidth) - left - width,
      top: top,
      bottom: (offsetParent === null || offsetParent === void 0 ? void 0 : offsetParent.offsetHeight) - top - height
    },
    viewport: boundingClient
  };
};