import { PatternProps } from '@codecademy/gamut-patterns';
import * as React from 'react';
export type ProgressBarProps = {
    className?: string;
    /**
     * Whether to increase size and display the percentage as text.
     */
    size?: 'small' | 'medium' | 'large' | 'xl';
    /**
     * Minimum amount of the bar to fill in visually.
     */
    minimumPercent?: number;
    /**
     * How much of the bar to fill in, as a number in [0, 100].
     */
    percent: number;
    /**
     * Base variant display themes.
     */
    variant: 'blue' | 'yellow' | 'default';
    /**
     * Pattern component to use as a background.
     */
    pattern?: React.ComponentType<PatternProps>;
};
export declare const ProgressBar: React.FC<ProgressBarProps>;
