import { ColorMode } from '@codecademy/gamut-styles';
import { AnimatePresence } from 'framer-motion';
import * as React from 'react';
import { BodyPortal } from '../BodyPortal';
import { Box } from '../Box';
import { FadeInSlideOut } from '../Motion/FadeInSlideOut';
import { Toast } from '../Toast/Toast';
import { jsx as _jsx } from "react/jsx-runtime";
export var Toaster = function Toaster(_ref) {
  var _ref$toasts = _ref.toasts,
    toasts = _ref$toasts === void 0 ? [] : _ref$toasts,
    _onClose = _ref.onClose,
    _ref$colorMode = _ref.colorMode,
    colorMode = _ref$colorMode === void 0 ? 'light' : _ref$colorMode;
  return /*#__PURE__*/_jsx(BodyPortal, {
    children: /*#__PURE__*/_jsx(ColorMode, {
      mode: colorMode,
      children: /*#__PURE__*/_jsx(Box, {
        right: 16,
        bottom: 88,
        position: "fixed",
        "aria-live": "polite",
        children: /*#__PURE__*/_jsx(AnimatePresence, {
          children: toasts.map(function (toast) {
            return /*#__PURE__*/_jsx(FadeInSlideOut, {
              children: /*#__PURE__*/_jsx(Toast, {
                onClose: function onClose() {
                  return _onClose(toast.id);
                },
                title: toast.title,
                icon: toast.icon,
                children: toast.children
              })
            }, toast.id);
          })
        })
      })
    })
  });
};