function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0) { ; } } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useLayoutEffect, useRef, useState } from 'react';
import * as React from 'react';
import { Box, FlexBox } from '../Box';
import { Popover } from '../Popover';
import { TargetContainer } from './elements';
import { tooltipDefaultProps } from './types';
import { escapeKeyPressHandler, getAccessibilityProps, getPopoverAlignment } from './utils';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export var FloatingToolTip = function FloatingToolTip(_ref) {
  var _ref$alignment = _ref.alignment,
    alignment = _ref$alignment === void 0 ? tooltipDefaultProps.alignment : _ref$alignment,
    children = _ref.children,
    focusable = _ref.focusable,
    id = _ref.id,
    target = _ref.target,
    _ref$widthMode = _ref.widthMode,
    widthMode = _ref$widthMode === void 0 ? tooltipDefaultProps.widthMode : _ref$widthMode;
  var ref = useRef(null);
  var _useState = useState(0),
    _useState2 = _slicedToArray(_useState, 2),
    offset = _useState2[0],
    setOffset = _useState2[1];
  var _useState3 = useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    isOpen = _useState4[0],
    setIsOpen = _useState4[1];
  var _useState5 = useState(false),
    _useState6 = _slicedToArray(_useState5, 2),
    isFocused = _useState6[0],
    setIsFocused = _useState6[1];
  useLayoutEffect(function () {
    if (ref !== null && ref !== void 0 && ref.current) {
      setOffset(-ref.current.clientWidth / 2 + 32);
    }
  }, []);
  var accessibilityProps = getAccessibilityProps({
    focusable: focusable,
    id: id,
    isOpenPopoverToolTip: isOpen
  });
  var popoverAlignments = getPopoverAlignment({
    alignment: alignment
  });
  var handleShowHideAction = function handleShowHideAction(_ref2) {
    var type = _ref2.type;
    if (type === 'focus' && !isOpen) {
      setIsOpen(true);
      setIsFocused(true);
    }
    if (type === 'blur' && isOpen) {
      setIsOpen(false);
      setIsFocused(false);
    }
    if (type === 'mouseenter' && !isOpen) {
      setIsOpen(true);
    }
    if (type === 'mouseleave' && isOpen && !isFocused) {
      setIsOpen(false);
    }
  };
  return /*#__PURE__*/_jsxs(Box, {
    position: "relative",
    display: "inline-flex",
    onMouseLeave: function onMouseLeave(e) {
      return handleShowHideAction(e);
    },
    children: [/*#__PURE__*/_jsx(TargetContainer, _objectSpread(_objectSpread({
      onKeyDown: function onKeyDown(e) {
        return escapeKeyPressHandler(e);
      },
      onFocus: function onFocus(e) {
        handleShowHideAction(e);
      },
      onBlur: function onBlur(e) {
        handleShowHideAction(e);
      },
      onMouseEnter: function onMouseEnter(e) {
        return handleShowHideAction(e);
      },
      ref: ref
    }, accessibilityProps), {}, {
      children: target
    })), /*#__PURE__*/_jsx(Popover, _objectSpread(_objectSpread({}, popoverAlignments), {}, {
      animation: "fade",
      "aria-live": "polite",
      horizontalOffset: offset,
      isOpen: isOpen,
      outline: true,
      role: "tooltip",
      variant: "secondary",
      skipFocusTrap: true,
      targetRef: ref,
      widthRestricted: widthMode === 'standard',
      children: /*#__PURE__*/_jsx(FlexBox, {
        id: id,
        alignItems: "flex-start",
        flexDirection: "column",
        children: children
      })
    }))]
  });
};