function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import * as React from 'react';
import { TargetContainer, ToolTipBody, ToolTipContainer, TooltipWrapper } from './elements';
import { tooltipDefaultProps } from './types';
import { escapeKeyPressHandler, getAccessibilityProps } from './utils';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export var InlineToolTip = function InlineToolTip(_ref) {
  var _ref$alignment = _ref.alignment,
    alignment = _ref$alignment === void 0 ? tooltipDefaultProps.alignment : _ref$alignment,
    children = _ref.children,
    focusable = _ref.focusable,
    id = _ref.id,
    target = _ref.target,
    _ref$widthMode = _ref.widthMode,
    widthMode = _ref$widthMode === void 0 ? tooltipDefaultProps.widthMode : _ref$widthMode;
  var accessibilityProps = getAccessibilityProps({
    focusable: focusable,
    id: id
  });
  return /*#__PURE__*/_jsxs(TooltipWrapper, {
    children: [/*#__PURE__*/_jsx(TargetContainer, _objectSpread(_objectSpread({
      onKeyDown: function onKeyDown(e) {
        return escapeKeyPressHandler(e);
      }
    }, accessibilityProps), {}, {
      children: target
    })), /*#__PURE__*/_jsx(ToolTipContainer, {
      alignment: alignment,
      "aria-live": "polite",
      as: "div",
      id: id,
      role: "tooltip",
      children: /*#__PURE__*/_jsx(ToolTipBody, {
        alignment: alignment.includes('center') ? 'centered' : 'aligned',
        color: "currentColor",
        minWidth: widthMode === 'unlimited' ? 'initial' : '4rem',
        children: children
      })
    })]
  });
};