function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import { fontSmoothPixel, timing, variant } from '@codecademy/gamut-styles';
import { toolTipAlignmentArray } from './types';
import { createToolTipVariantFromAlignment, createVariantsFromAlignments } from './utils';
export var tooltipBackgroundColor = "background-contrast";
export var tooltipArrowHeight = "1rem";
var containerOffsetVertical = 12;
export var centerMaxWidth = {
  maxWidth: '8rem'
};
export var alignedMaxWidth = {
  maxWidth: '16rem'
};
export var topStyles = {
  bottom: 'calc(100% + 4px)',
  pb: containerOffsetVertical
};
export var topStylesAfter = {
  borderColor: 'currentColor',
  borderWidth: '0 1px 1px 0',
  bottom: '0.25rem'
};
export var bottomStyles = {
  top: 'calc(100% + 4px)',
  pt: containerOffsetVertical
};
export var bottomStylesAfter = {
  borderColor: 'currentColor',
  borderWidth: '1px 0 0 1px',
  top: '0.25rem'
};
export var centerStyles = _objectSpread(_objectSpread({}, centerMaxWidth), {}, {
  left: 'calc(50% - 4rem)'
});
export var centerStylesAfter = {
  left: 'calc(50% - 0.5rem)'
};
export var leftStyles = _objectSpread(_objectSpread({}, alignedMaxWidth), {}, {
  justifyContent: 'flex-end',
  left: 'calc(50% - 14rem)'
});
export var leftStylesAfter = {
  right: '1.5rem'
};
export var rightStyles = _objectSpread(_objectSpread({}, alignedMaxWidth), {}, {
  left: 'calc(50% - 2rem)'
});
export var rightStylesAfter = {
  left: '1.5rem'
};
var tooltipVariantStyles = createVariantsFromAlignments(toolTipAlignmentArray, createToolTipVariantFromAlignment);
export var toolTipAlignmentVariants = variant({
  prop: 'alignment',
  base: {
    bg: 'transparent',
    fontSmoothPixel: fontSmoothPixel,
    display: 'flex',
    transition: "opacity ".concat(timing.fast),
    transitionDelay: "".concat(timing.fast),
    position: 'absolute',
    width: '70vw',
    zIndex: 1,
    opacity: 0,
    visibility: 'hidden',
    '&::after': {
      bg: tooltipBackgroundColor,
      content: '""',
      display: 'block',
      height: "".concat(tooltipArrowHeight),
      position: 'absolute',
      transform: 'rotate(45deg)',
      width: "".concat(tooltipArrowHeight),
      borderStyle: 'solid'
    }
  },
  variants: tooltipVariantStyles
});
export var toolTipBodyAlignments = variant({
  prop: 'alignment',
  variants: {
    centered: {
      m: 'auto',
      p: 8,
      textAlign: 'center'
    },
    aligned: {
      p: 16
    }
  }
});
export var toolTipBodyCss = {
  bg: tooltipBackgroundColor,
  color: 'text-accent',
  border: 1,
  boxShadow: 'none',
  borderRadius: '3px',
  display: 'inline-block',
  fontSize: 14,
  lineHeight: 'base'
};