function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import { bottomStyles, bottomStylesAfter, centerStyles, centerStylesAfter, leftStyles, leftStylesAfter, rightStyles, rightStylesAfter, topStyles, topStylesAfter } from './styles';
export var getPopoverAlignment = function getPopoverAlignment(_ref) {
  var _ref$alignment = _ref.alignment,
    alignment = _ref$alignment === void 0 ? 'top-left' : _ref$alignment;
  var popoverAlignment = {
    align: 'right',
    beak: 'right',
    position: 'above'
  };
  if (alignment.includes('bottom')) popoverAlignment.position = 'below';
  if (alignment.includes('right')) {
    popoverAlignment.align = 'left';
    popoverAlignment.beak = 'left';
  }
  return popoverAlignment;
};
export var createToolTipVariantFromAlignment = function createToolTipVariantFromAlignment(alignment) {
  var styleObject = {};
  var styleObjectAfter = {};
  if (alignment.includes('top')) {
    styleObject = _objectSpread({}, topStyles);
    styleObjectAfter = _objectSpread({}, topStylesAfter);
  } else {
    styleObject = _objectSpread({}, bottomStyles);
    styleObjectAfter = _objectSpread({}, bottomStylesAfter);
  }
  if (alignment.includes('center')) {
    styleObject = _objectSpread(_objectSpread({}, styleObject), centerStyles);
    styleObjectAfter = _objectSpread(_objectSpread({}, styleObjectAfter), centerStylesAfter);
  } else if (alignment.includes('right')) {
    styleObject = _objectSpread(_objectSpread({}, styleObject), rightStyles);
    styleObjectAfter = _objectSpread(_objectSpread({}, styleObjectAfter), rightStylesAfter);
  } else {
    styleObject = _objectSpread(_objectSpread({}, styleObject), leftStyles);
    styleObjectAfter = _objectSpread(_objectSpread({}, styleObjectAfter), leftStylesAfter);
  }
  return _objectSpread(_objectSpread({}, styleObject), {}, {
    '&::after': styleObjectAfter
  });
};
export var createVariantsFromAlignments = function createVariantsFromAlignments(array, composeStyleObjectFunc) {
  var variantsObject = Object.fromEntries(array.map(function (alignment) {
    var alignmentStyles = composeStyleObjectFunc(alignment);
    return [alignment, alignmentStyles];
  }));
  return variantsObject;
};
export var escapeKeyPressHandler = function escapeKeyPressHandler(event) {
  if (event.key === 'Escape') {
    event.target.blur();
  }
};
export var getAccessibilityProps = function getAccessibilityProps(_ref2) {
  var focusable = _ref2.focusable,
    id = _ref2.id,
    isOpenPopoverToolTip = _ref2.isOpenPopoverToolTip;
  // Since PopoverToolTips are removed from the DOM, when they are inactive they need an aria-label instead of aria-labelledby
  var labeling = isOpenPopoverToolTip === undefined || isOpenPopoverToolTip ? {
    'aria-labelledby': id
  } : {
    'aria-describedby': id
  };
  // ToolTips sometimes contain actual <button>s, which cannot be a child of a button.
  // This element still needs tab focus so we must use the `tabIndex=0` hack.
  return _objectSpread(_objectSpread({}, labeling), {}, {
    role: focusable ? 'button' : undefined,
    tabIndex: focusable ? 0 : undefined,
    'aria-label': focusable ? 'tooltip' : undefined
  });
};