export declare const typographyStyleVariants: {
    readonly 'title-xxl': {
        readonly fontSize: 64;
        readonly fontWeight: "title";
        readonly lineHeight: "title";
    };
    readonly 'title-xl': {
        readonly fontSize: 44;
        readonly fontWeight: "title";
        readonly lineHeight: "title";
    };
    readonly 'title-lg': {
        readonly fontSize: 34;
        readonly fontWeight: "title";
        readonly lineHeight: "spacedTitle";
    };
    readonly 'title-md': {
        readonly fontSize: 26;
        readonly fontWeight: "title";
        readonly lineHeight: "spacedTitle";
    };
    readonly 'title-sm': {
        readonly fontSize: 22;
        readonly fontWeight: "title";
        readonly lineHeight: "spacedTitle";
    };
    readonly 'title-xs': {
        readonly fontSize: 20;
        readonly fontWeight: "title";
        readonly lineHeight: "spacedTitle";
    };
    readonly 'p-large': {
        readonly fontSize: 18;
        readonly fontWeight: "base";
        readonly lineHeight: "base";
    };
    readonly 'p-base': {
        readonly fontSize: 16;
        readonly fontWeight: "base";
        readonly lineHeight: "base";
    };
    readonly 'p-small': {
        readonly fontSize: 14;
        readonly fontWeight: "base";
        readonly lineHeight: "base";
    };
};
export declare const typographyElementVariants: {
    readonly h1: {
        readonly fontSize: 64;
        readonly fontWeight: "title";
        readonly lineHeight: "title";
    };
    readonly h2: {
        readonly fontSize: 44;
        readonly fontWeight: "title";
        readonly lineHeight: "title";
    };
    readonly h3: {
        readonly fontSize: 34;
        readonly fontWeight: "title";
        readonly lineHeight: "spacedTitle";
    };
    readonly h4: {
        readonly fontSize: 26;
        readonly fontWeight: "title";
        readonly lineHeight: "spacedTitle";
    };
    readonly h5: {
        readonly fontSize: 22;
        readonly fontWeight: "title";
        readonly lineHeight: "spacedTitle";
    };
    readonly h6: {
        readonly fontSize: 20;
        readonly fontWeight: "title";
        readonly lineHeight: "spacedTitle";
    };
    readonly p: {
        readonly fontSize: 16;
        readonly fontWeight: "base";
        readonly lineHeight: "base";
    };
    readonly small: {
        readonly display: "inline-block";
        readonly fontSize: 14;
        readonly fontWeight: "base";
        readonly lineHeight: "base";
    };
    readonly strong: {
        readonly fontSize: "inherit";
        readonly fontWeight: "title";
        readonly display: "inline-block";
    };
    readonly code: {
        readonly fontFamily: "monospace";
        readonly display: "inline-block";
    };
    readonly span: {
        readonly fontSize: "inherit";
        readonly display: "inline-block";
    };
    readonly div: {};
    readonly figcaption: {};
    readonly label: {};
};
export declare const typographyUtilities: {
    readonly truncateLines: readonly [1, 2, 3, 4, 5];
    readonly truncation: readonly ["ellipsis", "fade"];
    readonly smoothing: readonly [true, false];
    readonly screenreader: readonly [true, false];
};
