import * as React from 'react';
import ReactPlayer from 'react-player';
/**
 * @remarks ReactPlayer has optional key 'wrapper' that we require for the onReady callback
 */
export type ReactPlayerWithWrapper = ReactPlayer & {
    wrapper: HTMLElement;
};
export type VideoProps = {
    videoUrl: string;
    videoTitle?: string;
    placeholderImage?: string | boolean;
    autoplay?: boolean;
    controls?: boolean;
    loop?: boolean;
    muted?: boolean;
    className?: string;
    onReady?: (player: ReactPlayerWithWrapper) => void;
    onPlay?: () => void;
};
export declare const Video: React.FC<VideoProps>;
