function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0) { ; } } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { PlayIcon } from '@codecademy/gamut-icons';
import cx from 'classnames';
import { useState } from 'react';
import * as React from 'react';
import ReactPlayer from 'react-player';
import { useIsMounted } from '../utils';
// eslint-disable-next-line gamut/no-css-standalone
import styles from './styles/index.module.scss';
import { jsx as _jsx } from "react/jsx-runtime";
var OverlayPlayButton = function OverlayPlayButton(_ref) {
  var videoTitle = _ref.videoTitle;
  return /*#__PURE__*/_jsx("div", {
    className: styles.overlay,
    role: "button",
    "aria-label": "play video".concat(videoTitle ? ": ".concat(videoTitle) : ''),
    children: /*#__PURE__*/_jsx(PlayIcon, {
      className: styles.hoverButton
    })
  });
};

/**
 * @remarks ReactPlayer has optional key 'wrapper' that we require for the onReady callback
 */

export var Video = function Video(_ref2) {
  var videoUrl = _ref2.videoUrl,
    videoTitle = _ref2.videoTitle,
    placeholderImage = _ref2.placeholderImage,
    autoplay = _ref2.autoplay,
    controls = _ref2.controls,
    loop = _ref2.loop,
    muted = _ref2.muted,
    className = _ref2.className,
    _onReady = _ref2.onReady,
    onPlay = _ref2.onPlay;
  var _useState = useState(true),
    _useState2 = _slicedToArray(_useState, 2),
    loading = _useState2[0],
    setLoading = _useState2[1];
  var isMounted = useIsMounted();
  return /*#__PURE__*/_jsx("div", {
    className: cx(styles.videoWrapper, loading && styles.loading, className),
    children: isMounted ? /*#__PURE__*/_jsx(ReactPlayer, {
      url: videoUrl,
      light: placeholderImage,
      title: videoTitle,
      playing: autoplay,
      className: styles.iframe,
      controls: controls === undefined ? true : controls,
      loop: loop,
      muted: muted,
      playIcon: /*#__PURE__*/_jsx(OverlayPlayButton, {
        videoTitle: videoTitle
      }),
      onReady: function onReady(player) {
        _onReady === null || _onReady === void 0 ? void 0 : _onReady(player);
        setLoading(false);
      },
      onPlay: onPlay
    }) : null
  });
};